{-----------------------------------------------------------------------------}
{ Calculating constant expressions.			   (c) 1989, 1990 YGP }

  procedure ConstOperations(var fa: Attribute; fsy: symbol);
  begin { ConstOperations }					    {$ifNdef Q}
    if (ga.t = nil) or ((fa.t = nil) and (fsy <> neg_sy)) then begin
      ga.t:= nil; (*) return {*) exit {*};
    end { if }; 						       {$endif}
		       { fa is dummy (nil) if negative operation is requested }
    if (fa.t <> nil) and (fsy <> neg_sy) then begin
      if fa.t^.TForm = SubRange 	   then fa.t:= fa.t^.RangeType;
      if fa.t = wrd_t			   then fa.t:= lwrd_t;
      if (fa.t = int_t) or (fa.t = card_t) then fa.t:= lint_t;
    end { if };
								    {$ifNdef Q}
    if ga.t <> nil then 					 {$endif} begin
      if ga.t^.TForm = SubRange 	     then ga.t:= ga.t^.RangeType;
      if ga.t = wrd_t			     then ga.t:= lwrd_t;
      if (ga.t = int_t) or (ga.t = card_t)   then ga.t:= lint_t;
      if (fa.t = lwrd_t) and (ga.t = lint_t) then ga.t:= lwrd_t;
      if (ga.t = lwrd_t) and (fa.t = lint_t) then fa.t:= lwrd_t;
    end { if };

    case fsy of
      asterisk, plus_sy, minus_sy: begin
	if (ga.t <> fa.t) or (ga.t <> lint_t) then begin
	  err_nil(184); (*) return {*) exit {*}; end
	else begin
	  case fsy of
	    asterisk: ga.Aval.i:= fa.Aval.i * ga.Aval.i;
	    plus_sy:  ga.Aval.i:= fa.Aval.i + ga.Aval.i;
	    minus_sy: ga.Aval.i:= fa.Aval.i - ga.Aval.i;
	  end { case };
	end { if };
      end { when *, +, - };

      slash: begin { / real division }
	error(193); ga.t:= real_t;
      end { when slash };

      div_sy, mod_sy: begin
	if (ga.t <> fa.t) or (ga.t <> lint_t) then begin
	  err_nil(184); (*) return {*) exit {*}; end
	else if ga.Aval.i = 0 then
	  error(185)
	else if fsy = div_sy then
	  ga.Aval.i:= fa.Aval.i div ga.Aval.i
	else begin
	  ga.Aval.i:= fa.Aval.i mod ga.Aval.i;
	end { if }
      end { when div mod };

      andJWsy, orJWsy, and_sy, or_sy, xor_sy: begin
	if fsy = andJWsy then fsy:= and_sy;
	if fsy = orJWsy  then fsy:= or_sy;
	if (ga.t <> fa.t) or ((ga.t <> bool_t) and (ga.t <> lwrd_t)) then begin
	  err_nil(184); (*) return {*) exit {*}; end
	else begin
	  case fsy of
	    and_sy: ga.Aval.i:= LongWord(fa.Aval.i) and LongWord(ga.Aval.i);
	    or_sy:  ga.Aval.i:= LongWord(fa.Aval.i) or	LongWord(ga.Aval.i);
	    xor_sy: ga.Aval.i:= LongWord(fa.Aval.i) xor LongWord(ga.Aval.i);
	  end { case };
	end { if };
      end { when and, or, xor, &, | };

      neg_sy: begin	      { '-' negate (neg_sy) is never returned by insy }
	if ga.t = lint_t then	       { but is generated by SimpleExpression }
	  ga.Aval.i:= -ga.Aval.i	 {       }
	else if ga.t = real_t then	 {     }
	  ga.Aval.r:= -ga.Aval.r       {    .  -0.55 }
	else begin
	  err_nil(186);
	end { if };
      end { when neg_sy };
    end { case };
  end { ConstOperations };

  procedure MinMaxProc(StdPF: StdProcs; fsys: syset);
    var lidp: idp;
  begin
    if sy = ident then begin
      QualIdent([TypeId], lidp);				    {$ifNdef Q}
      if lidp^.IdType <> nil then				 {$endif} begin
	if ESubRange < lidp^.IdType^.TForm then begin
	  error(164); ga.Aval.i:= 0; end
	else begin
	  GetBounds(lidp^.IdType, ga.amin, ga.amax);
	  if StdPF = StdMin then
	    ga.Aval.i:= ga.amin
	  else begin
	    ga.Aval.i:= ga.amax;
	  end { if };
	end { if };
      end { if };
      ga.t:= lidp^.IdType; insy; end
    else begin
      ga.Aval.i:= 0; ga.t:= lint_t;
      ErrSkip(50, fsys + [rpar]);
      {$ifdef Q} halt; {$endif}
    end { if };
  end { MinMaxProc };

  procedure ConstRoutine(fsys: syset; fidp: idp);
    label NotSupported;
  begin
    insy; (*) incl(fsys, rpar); {*) fsys:= fsys + [rpar]; {*}
    if sy <> lpar then
      error(45)
    else begin
      insy;
      with fidp^ do begin
	if IdFlags and _standard <> 0 then begin
	  if (StdPF <> StdMin) and (StdPF <> StdMax) then begin
	    Constant(fsys);
	  end { if };

	  case StdPF of

	    StdOdd: begin					    {$ifNdef Q}
	      if ga.t <> nil then				 {$endif} begin
		if (ga.t^.TForm = SubRange) then begin
		  ga.t:= ga.t^.RangeType;
		end { if };					    {$ifNdef Q}
		if ga.t <> nil then				 {$endif} begin
		  if (ga.t^.TForm <> Scalar) or (ga.t = char_t) then
		    error(157)
		  else begin
		    ga.Aval.i:= ga.Aval.i and byte(1);
		  end { if };
		end { if };
	      end { if };
	      ga.t:= bool_t;
	    end { when odd };

	    StdMin, StdMax: begin
	      MinMaxProc(StdPF, fsys);
	    end { when min, max };

	    StdOrd: begin					    {$ifNdef Q}
	      if ga.t <> nil then				 {$endif} begin
		if (ESubRange < ga.t^.TForm) or (1 < ga.t^.TSize) then
		  error(157)
		else if (ga.t^.TForm = Enumerated) or  {     }
			(ga.t^.TForm = ESubRange) or	  {    ord  }
			(ga.t = char_t) then begin		    { integer }
		  GetBounds(ga.t, ga.amin, ga.amax);
		  if ga.amax <= 255 then
		    ga.t:= scrd_t
		  else begin
		    ga.t:= ntrl_t;
		  end { if };
		end { if };
	      end { if };
	    end { when ORD };

	    StdSucc, StdPred: begin				    {$ifNdef Q}
	      if ga.t <> nil then				 {$endif} begin
		if ESubRange < ga.t^.TForm then
		  error(157)
		else begin
		  if StdPF = StdSucc then
		    inc(ga.Aval.i)
		  else begin
		    dec(ga.Aval.i)
		  end { if };
		end { if };
	      end { if };
	    end { when succ, pred };

	    StdSqr, StdAbs: begin				    {$ifNdef Q}
	      if ga.t <> nil then				 {$endif} begin
		case ga.t^.TForm of
		  Scalar,
		  SubRange: begin
		    if StdPF = StdAbs then
		      ga.Aval.i:= abs(ga.Aval.i)
		    else begin
		      ga.Aval.i:= sqr(ga.Aval.i);
		    end { if };
		  end { when scalar or subrange };

		  Reals: begin
		    error(193);
		  end { Reals };

		else (*):(*)
		  error(157)
		end { case };
	      end { if };
	    end { when sqr, abs };

	  else (*):(*)
	    goto NotSupported;
	  end { case }; end { when standard proc/func }
	else begin
NotSupported:
	  error(192);
	  while sy <> rpar do begin
	    if sy = comma then insy;
	    Constant(fsys+[comma]);
	  end { while };
	end { if };
	TestSy(rpar);
      end { with };
    end { if };
  end { ConstRoutine };

  procedure Constant(fsys: syset);
    var heap: pointer;
	FirstEr: boolean;

    function RealCnst: boolean;
      var r: boolean;
    begin
      r:= ga.t = real_t;
      if r then begin
	ga.t:= nil;
	if FirstEr then Error(193);
      end;
      RealCnst:= r; FirstEr:= false;
    end { RealCnst };

    procedure Expression(fsys: syset);
      var la: Attribute; lsy: symbol;

      procedure SimpleExpression(fsys: syset);
	var la: Attribute; lsy: symbol;
	    test, negative: boolean;

	procedure Term{fsys: syset};
	  var la: Attribute; lsy: symbol;
	      test: boolean;

	  procedure Factor{fsys: syset};
	    var lidp: idp; lsy: symbol;
	  begin     {     a cnst  ([1..5,6,7..9]) }
	    if not(sy in FacBegSys - [lbra]) then begin
	      ErrSkip(183, fsys + FacBegSys);
	    end { if };

	    lsy:= sy;

	    case lsy of
	      nil_sy: begin
		ga.t:= ptr_t; ga.Aval.i:= 0;
	      end { when nil };

	      ident: begin
		QualIdent([ConstId, ECnstId, FuncId], lidp);
		ga.t:= lidp^.IdType;

		case lidp^.IdClass of
		  ConstId: begin
		    ga.Aval:= lidp^.IdValue;
		  end { when ConstId };

		  ECnstId: begin
		    ga.Aval.i:= lidp^.No;
		  end { wqhen ECnstId };

		  FuncId: begin
		    lsy:= lpar; {   insy - }
		    ConstRoutine(fsys, lidp)
		  end { when FuncId };

		  else (*):(*) Error(-74);	{       }
		end { case };
								    {$ifNdef Q}
		if ga.t <> nil then				 {$endif} begin
		  if ga.t^.TForm = SubRange then begin
		    ga.t:= ga.t^.RangeType;
		  end { if };
		  if (ga.t = int_t) or (ga.t = card_t) then begin
		    ga.t:= lint_t;
		  end { if };
		  if ga.t = wrd_t then begin
		    ga.t:= lwrd_t;
		  end { if };
		end { if };
	      end { when ident };

	      i_const: begin
		ga.t:= lint_t; ga.Aval.i:= Last.I;
	      end { when i_const };

	      r_const: begin
		ga.t:= real_t; ga.Aval.r:= Last.R;
	      end { when r_const };

	      c_const: begin
		if length(last.s^) = 1 then begin
		  ga.t:= char_t; ga.Aval.i:= ord(last.s^[1]); end
		else begin
		  ga.t:= str_t; 		   { insy     }
		  with ga.Aval do begin 	  {       }
		    word(COffs):= $ffff;	    {     }
		    CSegNo:= SegNo; StrPtr:= Last.s;
		  end { with ga.Aval };
		  AllocateConst;
		end { if };
	      end { when c_const };

	      lpar: begin
		insy; expression(fsys+[rpar]);
		TestSy(rpar);
	      end { when '(' };

	      not_sy: begin
		insy; Factor{fsys};
		ConstOperations(ga, not_sy);
	      end { when not_sy };
	    end { case lsy };

	    (* if not (lsy in [lpar, not_sy]) then insy;   ;  , ... *)
            if lsy in [nil_sy, ident, i_const, r_const, c_const] then insy;

	    ga.kind:= cnst;
	    if not (sy in fsys) then begin
	      ErrSkip(214, fsys + (FacBegSys - [rpar]));
	    end { if }
	  end { Factor };

	begin { Term }
	  Factor{fsys + MulOps};
	  while sy in MulOps do begin
	    la:= ga; lsy:= sy; test:= RealCnst;
	    insy; Factor{fsys + MulOps}; test:= test and RealCnst;
	    if not test then ConstOperations(la, lsy);
	  end { while sy in MulOps };
	end { Term };

      begin { SimpleExpression }
	negative:= false;
	if sy in [plus_sy, minus_sy] then begin
	  negative:= sy = minus_sy; insy;
	end { if };

	Term{fsys + AddOps};
	if negative then ConstOperations(la, neg_sy);		{ la is dummy }
	while sy in AddOps do begin
	  la:= ga; lsy:= sy;		 {  OrElse, AndThen     }
	  test:= RealCnst;
	  insy; Term{fsys + AddOps};	 { report-    div 0 ...    }
	  test:= test or RealCnst;
	  if not test then ConstOperations(la, lsy);
	end { while sy in AddOps };
      end { SimpleExpression };

    begin { Expression }
      SimpleExpression(fsys + RelOps);
      if sy in RelOps then begin
	error(191); la:= ga; lsy:= sy;
	insy; SimpleExpression(fsys);
	(*ConstOperations(la, lsy);     REL  *)
      end { if };
    end { Expression };

  begin { Constant }
    fsys:= fsys +AddOps +MulOps; {  Expression ( BodyPart)   }
    FirstEr:= true; ga.t:= nil; ga.kind:= cnst; mark(heap);
    Expression(fsys); CorrectConstType;
  end { Constant };

{-----------------------------------------------------------------------------}
