{-----------------------------------------------------------------------------}
{ Finish up compilation.				   (c) 1989, 1990 YGP }

  type SegInfo = packed record
	 name:	alpha;
	 Start,
	 Size,
	 No,
	 Next:	cardinal;
	 unused: packed array [0..15] of byte;
       end { SegInfo };

  (*) segment (*)
  procedure FinishSegment;
    type SysInfo = packed record    {  32      }
	   name:       alpha;			     {  -    }
	   Wsz, Bsex:  byte;			       { word size & byte sex }
	   Vmaj, Vmin: byte;			    { Ycode version (maj.min) }
	   TotalSz,					 { total segment size }
	   ConstSz:    cardinal;			 { constant pool size }
	   unused:     packed array [0..9] of byte;
	   RTptr,				{ offset to relocation tables }
	   PDptr,				  { offset to proc dictionary }
	   CPptr:      cardinal;		    { offset to constant pool }
	 end { SysInfo };

	 wa = array [0..255] of word;				 { word array }

	 TempRec = packed record		  { items from temporary file }
	   case descriptor: TmpDesc of
	     _const_:	  (cnst: string);		    { strings or sets }
	     _relinfo_:   (zero: byte; size: cardinal);
	     _procoffs_:  (Pno: byte; offset: word);
	     _constpool_: (CPsize: cardinal);
	 end { TempRec };

    var ParaNo:  cardinal;	   { paragraph No of info for current segment }
	wrk,
	freendx: integer;		{      ProcBuff }
	pd_pos, 		   { position in code file of proc dictionary }
	cp_pos, 			     { position in file of const pool }
	rt_pos:  LongInt;		      { position in file of rel table }
	sy:	 ^SysInfo;			    {   ProcBuff }
	Pdict:	 ^wa;
	ti:	 ^TempRec;
	si:	 ^SegInfo;

    procedure RestoreOldSegment;
      var tsi: ^TmpSaveInfo;
	  offs: word;
	  td:	TmpDesc;
    begin	  {      ,  }
		      {      temporary file }
      tsi:= addr(ProcBuff);
      Seek(TempFile, TempStart); BlockRead(TempFile, tsi^, sizeof(tsi^));
      if IOresult <> 0 then error(248);

      with tsi^ do begin
	NextProc:= ProcNxt;
	TempStart:= TmpStrt;	TempItems:= TmpItms; SegStart:= SegStrt;
	CodeSize:= CdSize;	CpoolSz:= CpSize;    RelctSz:= RlctSz;

	Seek(TempFile, TmpPos);
	if CdePos <> 0 then begin
	  Seek(CodeFile, longint(CdePos) + longint(OKcode) * 512);
	end { if };

	td:= _procoffs_;	 {  TempFile      }
	to_temp(td, 1); to_temp(CurProc, 1);	 {    ProcDict }
	offs:= word($ff00) or word(level^.proc^.pf.seg);
	to_temp(offs, 2);
	inc(TempItems);

	level^.proc^.pf.num:= CurProc;	 {      }
	level^.proc^.pf.seg:= level^.PrevLevel^.Proc^.pf.seg; {   }
				  { internal     . }
      end { with };
    end { RestoreOldSegment };

    procedure GetItem;
    begin
      BlockRead(TempFile, ti^.descriptor, 1); if IOresult <> 0 then error(248);
      case ti^.descriptor of
	_const_: begin
	  BlockRead(TempFile, ti^.cnst, 1);
	  if IOresult <> 0 then error(248);
	  BlockRead(TempFile, ti^.cnst[1], length(ti^.cnst));
	end { when _const_ };

      _relinfo_: begin
	BlockRead(TempFile, ti^.zero, 3);
      end { when _relinfo_ };

      _procoffs_: begin
	BlockRead(TempFile, ti^.Pno, 3);
      end { when _procoffs_ };

      _constpool_: begin
	BlockRead(TempFile, ti^.CPsize, 2);
      end { when _constpool_ };

      else(*):(*)
	error(-17);
      end { case };
      if IOresult <> 0 then error(248);
    end { GetItem };

    procedure SwapCodeFile(Src, Dest, DestSize: cardinal);
      const save =   0; 	      { index in ProcBuff to save first block }
	    work = 512; 			 { index in ProcBuff for work }
      var SrcSize, TotalSize,
	  gcd, wrk, i, j, k, l: cardinal;

      procedure GetBlock(No, ndx: cardinal);
	var wrk: cardinal;
      begin
	Seek(CodeFile, longint(Src + No) * 512);
	if IOresult <> 0 then error(248);
	BlockRead(CodeFile, ProcBuff[ndx], 512, wrk);             {$ifdef SWAP}
          writeln('Read Block: ', Src + No, ', ', wrk, ' bytes read'); {$endif}
	if IOresult <> 0 then error(248);
	FillChar(ProcBuff[ndx+wrk], 512 - wrk, #0);    { fill rest with zeros }
      end { GetBlock };

      procedure PutBlock(No, ndx: cardinal);
      begin
	Seek(CodeFile, longint(Src + No) * 512);
	if IOresult <> 0 then error(248);                         {$ifdef SWAP}
                                   writeln('Write Block: ', Src + No); {$endif}
	BlockWrite(CodeFile, ProcBuff[ndx], 512);
	if IOresult <> 0 then error(248);
      end { PutBlock };

    begin { SwapCodeFile }
      {     ....xxxxxxxXXXXXX  CodeFile   ....XXXXXxxxxxxx  }
      { 		^-src  ^dest,  src, dest  destsize     }
      {        ProcBuff (   2 ).   }

      SrcSize:= Dest - Src;			  {   Src  }
      if (DestSize = 0) or (SrcSize = 0) then begin
	(*) return {*) exit {*};	    {       }
      end { if };
      TotalSize:= SrcSize + DestSize;
      gcd:= SrcSize; wrk:= DestSize;	    {   -   }
      while gcd <> wrk do begin
	if gcd < wrk then dec(wrk, gcd);
	if wrk < gcd then dec(gcd, wrk);
      end { while };

      for i:= 0 to gcd-1 do begin				{  SWAP }
	GetBlock(i, save); l:= i;
	for j:= 1 to TotalSize div gcd -1 do begin
	  k:= (l + SrcSize) mod TotalSize;	     { bump with wrap arround }
	  GetBlock(k, work); PutBlock(l, work); l:= k;	 { move block K --> L }
	end { for };
	PutBlock(l, save);
      end { for };
      {             
         segment-         
                 . }
	Seek(CodeFile, longint(Src + TotalSize) * 512);
    end { SwapCodeFile };

  begin { FinishSegment }
    if Errors <> 0 then begin	    {        }
      NextProc:= succ(level^.PrevLevel^.proc^.pf.num);	   {      }
      (*) return {*) exit {*};
    end { if };

    sy:= addr(ProcBuff); fillchar(sy^, sizeof(SysInfo), #0);
    with sy^ do begin		 { build system info (first 32 bytes of a seg }
      name:= level^.proc^.IdName; Wsz:= 16; Bsex:= 0; Vmaj:= 1; Vmin:= 10;
      ConstSz:= CpoolSz;
      PDptr:= CodeSize; CPptr:= CodeSize + NextProc * 2;
      RTptr:= CPptr + CpoolSz;
      if RelctSz = 0 then
	RTptr:= 0
      else begin
	inc(RelctSz, 2);		 {  $ffff    }
      end { if };

      inc(CodeSize, CpoolSz + RelctSz + NextProc * 2);
      TotalSz:= CodeSize;
      inc(TotalCode, CodeSize - RelctSz);
    end { with };

    WriteFname; write(message, level^.proc^.IdName: 9+LexLevel);
    write(' (', CodeSize - RelctSz);
    if RelctSz <> 0 then write(' + ', RelctSz);
    write(')');

    if word(SegStart) = $ffff then error(-16);

    pd_pos:= FilePos(Codefile);       { ProcDictionary     }
    cp_pos:= pd_pos + 2 * NextProc;		{ Cpool   ProcDict }
    rt_pos:= cp_pos + CpoolSz;		      { RelTbl   ConstPool }

    Seek(CodeFile, longint(OKcode + SegStart) * 512);
    to_code(sy^, SizeOf(SysInfo));

    Pdict:= addr(ProcBuff); Pdict^[0]:= pred(NextProc);      {   }

    freendx:= NextProc * 2; ti:= addr(ProcBuff[freendx]);

    Seek(TempFile, TempStart + SizeOf(TmpSaveInfo));

    while 0 < TempItems do begin
      GetItem; dec(TempItems);
      case ti^.descriptor of
	_const_: begin
	  Seek(CodeFile, cp_pos);
	  to_code(ti^.cnst, succ(length(ti^.cnst)));
	  inc(cp_pos, succ(length(ti^.cnst)));
	end { when _const_ };

	_relinfo_: begin
	  Seek(CodeFile, rt_pos); wrk:= ti^.size;
	  inc(rt_pos, wrk);
	  while wrk <> 0 do begin
	    ipc:= MaxCodeSz - freendx;
	    if wrk < ipc then ipc:= wrk;
	    BlockRead(TempFile, ProcBuff[freendx], ipc);
	    if IOresult <> 0 then error(248);
	    to_code(ProcBuff[freendx], ipc);
	    dec(wrk, ipc);
	  end { while };
	end { when _relinfo_ };

	_procoffs_: begin
	  Pdict^[ti^.Pno]:= ti^.offset;
	end { when _procoffs_ };

	_constpool_: begin
	  Seek(CodeFile, cp_pos); wrk:= ti^.CPsize;
	  inc(cp_pos, wrk);
	  while wrk <> 0 do begin
	    ipc:= MaxCodeSz - freendx;
	    if wrk < ipc then ipc:= wrk;
	    BlockRead(TempFile, ProcBuff[freendx], ipc);
	    if IOresult <> 0 then error(248);
	    to_code(ProcBuff[freendx], ipc);
	    dec(wrk, ipc);
	  end { while };
	end { when _constpool_ };

      else(*):(*)
	error(-17);
      end { case };
    end { while };

    Seek(CodeFile, pd_pos); to_code(Pdict^, cardinal(succ(Pdict^[0])) * 2);
    if RelctSz <> 0 then begin	     {  $ffff     }
      Seek(CodeFile, rt_pos); ipc:= -1;
      to_code(ipc, 2); inc(cp_pos, 2);
    end { if };

    inc(CodeSize, sizeof(SysInfo));
    CpoolSz:= (CodeSize + 511) div 512;       {      }

    ParaNo:= succ(LastPara); pd_pos:= 0;
    if LastPara = 0 then
      ParaNo:= 2
    else if ParaNo mod 16 = 0 then begin	    {     ? }
      ParaNo:= (OKcode + CpoolSz) * 16;
      pd_pos:= LongInt(OKcode + SegStart + CpoolSz) * 512;
      inc(CpoolSz);			       {     }
    end { if };

    if pd_pos = 0 then pd_pos:= LongInt(ParaNo) * 32;

    Seek(CodeFile, pd_pos);

    si:= addr(ProcBuff); fillchar(si^, sizeof(si^), #0);

    with si^ do begin
      name:= level^.proc^.IdName;
      Start:= OKcode; Size:= CodeSize;
      No:= SegNo; Next:= LastPara;
    end { SegInfo };

    to_code(si^, sizeof(seginfo)); LastPara:= ParaNo;
    if SegStart = 0 then
      Seek(CodeFile, cp_pos)
    else begin
      SwapCodeFile(OKcode, OKcode + SegStart, CpoolSz)
    end { if };
    inc(OKcode, CpoolSz);
    RestoreOldSegment;		    {      }
  end { FinishSegment };

{-----------------------------------------------------------------------------}

  (*) segment (*)
  procedure FinishUp;
    label ErrLab (*){*), exit{*};
    type Header = packed record      { Code file header and Module descriptor }
	    CODE:    word;			  { CodeFile const    ($C0DE) }
	    WrdSz:   byte;			  { Word Size	      ($10)   }
	    ByteSex: byte;			  { Byte Sex	      ($00)   }
	    VerMaj,				  { Version Major     (  1)   }
	    VerMin:  byte;			  {	    Minor     ( 00)   }
	    Unused:  word;			  { unused	      ($0000) }
	    PSize:   Cardinal;			  { Paragraph Size    ($0020) }
	    BSize:   Cardinal;			  { Block Size	      ($0200) }
	    Offset:  Cardinal;			  { Offset of ModDesc ($0001) }
	    boza:    packed array [0..13] of char;	   { fill to ParaSize }
	    SerNo:   LongWord;

	    Mname: alpha;					{ Module name }
	    MDver,					     { Module Version }
	    MDdate,						   { Date and }
	    MDtime:   Cardinal; 			{ Time of compilation }
	    NextMod:  Cardinal; 		     { Next Module Descriptor }
	    MainSeg:  Cardinal; 		  { Paragraph of Main Segment }
	    Language: Cardinal; 				   { Language }
	    CompStart,				     { Start of compiler info }
	    CompSize: Cardinal; 			      { Compiler Size }
	    UsgList:  Cardinal; 		       { Usage List paragraph }
	    U1, U2:   Cardinal; 				     { unused }
	    NExtrnl,				   { Number of External units }
	    NIntrnl:  ShortCard;		    { Number of Internal Segs }
	 end { Header };

	 UsesDescriptor = record
	   UDname: alpha;
	   UDver,
	   UDdate,
	   UDtime: word;
	   UDnext: word;
	   unused: array [0..7] of word;
	 end { UD };

    var si:   ^SegInfo;
	h:    ^Header;
	u:    ^UsesDescriptor;
	n:    natural;
	UsgP: cardinal;                                         {$ifdef UniPas}
        wrk_wrk,                                                       {$endif}
	wrk:  StringP;
	ext:  string[4];

    function HasIOerror: boolean;
    begin
      HasIOerror:= false;
      if IOresult <> 0 then begin
{$ifdef wrIO}
  write('$', word(IOresult));
{$endif}
	writeln('*** Error writing codefile');
	inc(Errors); HasIOerror:= true;
      end { if };
    end { HasIOerror };

    procedure SwapSequance(var fidp: idp);
      var lidp1, lidp: idp;
    begin
      lidp1:= nil; lidp:= fidp; fidp:= nil;
      while lidp <> nil do begin
	lidp1:= lidp^.next; lidp^.next:= fidp; fidp:= lidp; lidp:= lidp1;
      end { while };
    end { SwapSequance };

    var lunits: idp;
	n_units: shortcard;

  begin { FinishUp }							 (*){*)
    exiting:= true; if IOresult <> 0 then ;		   {   }

    inc(TotalLines, LineCnt);

    repeat close(Ifile[Ilevel].f^);  {   ,    }
      dec(Ilevel, ord(Ilevel <> 0));			     {   }
    until Ilevel = 0;

    if (Errors = 0) and not (UserBreak) then begin	    {    }
      WriteFname;
      if (Compilation = intface_sy) then begin
	write(message, ' ', prognm, #24#13);
        (*)
        write(Ifile[Ilevel].fname:15,'(',LLineCnt:4,') ',prognm)
        {*)
        if length(Ifile[Ilevel].fname) <= 15 then
          write(Ifile[Ilevel].fname:15)
        else begin
          write(MinimizeFname(Ifile[Ilevel].fname): 15);
        end;
        write('(',LLineCnt:4,') ',prognm)
        {*} end
      else begin			   {     . }
	writeln(message); Seek(CodeFile, longint(LastPara) * 32);
	if HasIOerror then goto ErrLab;
	si:= addr(ProcBuff); BlockRead(CodeFile, si^, sizeof(si^));
	if HasIOerror then goto ErrLab;
	Seek(CodeFile, longint(si^.start) * 512 + si^.size);
	if HasIOerror then goto ErrLab;
	Truncate(CodeFile);				   {  trunc- }

	UsgP:= 0;		  {     USES  }
	u:= addr(ProcBuff); Units:= Units^.next;     { Units    }
	SwapSequance(Units); fillchar(u^, sizeof(u^), #0);
	n_units:= Nunits;	   {  Nunits    IntfcOnly units }

	for n:= Nunits downto 1 do begin
	  lunits:= Units;
	  while lunits <> nil do begin
	    if (lunits^.IdClass <> UnitId) or	  { visible and non interface }
	       (lunits^.intface^.UnitNo <> n) then begin	 { units only }
	      lunits:= lunits^.next;
	      if lunits = nil then error(-44) end
	    else begin
	      if (lunits^.IdFlags and _interfaced <> 0) then
		dec(n_units)
	      else begin
		with u^ do begin
		  UDnext:= UsgP; UDname:= lunits^.IdName;
		  with lunits^.intface^ do begin
		    UDver:= ver; UDdate:= swap(date); UDtime:= swap(time);
		  end { with };
		end { with };

		if UsgP = 0 then
		  UsgP:= succ(LastPara)
		else begin
		  inc(UsgP);
		end { if };

		if UsgP mod 16 = 0 then begin	    {     ? }
		  UsgP:= OKcode * (512 div 32);
		  inc(OKcode);		       {     }
		end { if };

		Seek(CodeFile, longint(UsgP) * 32);
		BlockWrite(CodeFile, u^, sizeof(u^));
		if HasIOerror then goto ErrLab;
	      end { if };
	      lunits:= nil;				  { force while break }
	    end { if };
	  end { while };
	end { for };

	h:= addr(ProcBuff);	     {     2  }

	fillchar(h^, SizeOf(h^), #0);
	with h^ do begin
	  SerNo:= SerialNo;
	  CODE:= swap($C0DE); WrdSz:= 16; VerMaj:= 1; VerMin:= 10;
	  PSize:= 32; BSize:= 512; Offset:= 1; {      .1 }
	  boza:= #13#10'UniPascal'#13#10#26;           { fill in unused space }

	  move(prognm[1], Mname, 8);
	  Language:= swap($1000 + $100 + 10);			{ Pascal 1.10 }
	  MDdate:= swap(CDate); MDtime:= swap(CTime); MDver:= Cver;
	  MainSeg:= LastPara; UsgList:= UsgP;
	  NExtrnl:= N_units;				    {    }
	  Nintrnl:= NextSeg - N_units;		       {  segment- proc }
	end { with h^ };

	Seek(CodeFile, 0); BlockWrite(CodeFile, h^, sizeof(h^));
	if HasIOerror then goto ErrLab;
      end { if };

      wrk:= addr(ProcBuff); close(CodeFile); wrk^:= CURname^;
      while (wrk^ <> '') and not(wrk^[length(wrk^)] in ['\', ':']) do begin
	dec(wrk^[0]);
      end { while };
      insert(prognm, wrk^, length(wrk^)+1);
      case Compilation of
	intface_sy: ext:= '.SYM';                { .SYM  interface   }

	unit_sy,
	implmnt_sy: ext:= '.BDY';                    { .BDY  implementation }

	prog_sy:    ext:= '.PGM';                          { .PGM   }

      end { case };

      insert(ext, wrk^, length(wrk^)+1);
      remove(wrk^);	    (*) {*) if IOresult <> 0 then ;    {  }
      {$ifNdef UniPas}            {      UniDOS }
        rename(CURname^, wrk^);
      {$else}
        wrk_wrk:= addr(ProcBuff[100]);             {      }
        wrk_wrk^:= wrk^;          {      UniDOS }
        rename(CURname^, wrk^);          { rename  UniDOS    }
        wrk^:= wrk_wrk^;          {         }
      {$endif}
      if HasIOerror then goto ErrLab;
      if Compilation <> intface_sy then
	CURname^:= wrk^
      else begin
	SYMname^:= wrk^;
        if Cdate mod $20 = 0 then begin          {     }
          error(11);                                                { warning }
        end { if };
      end { if }; end
    else begin
      writeln;
      (*) if RTEno = 1 then writeln(' *** Insufficient memory'); (*)
ErrLab:
      Close(CodeFile);	  (*) {*) if IOresult <> 0 then ;      {  }
      Remove(CURname^);   (*) {*) if IOresult <> 0 then ;      {  }
      if (Compilation = unit_sy) and (CURname <> SYMname) then begin
	Remove(SYMname^); (*) {*) if IOresult <> 0 then ;      {  }
      end { if };
    end { if };
exit:
    writeln;
    if ((ErrLevel < 6) or (Errors = 0)) and not UserBreak then begin
      write('Successful compilation. ');
      if Warnings <> 0 then begin
	write(Warnings, ' warning');
	if Warnings > 1 then write('s');
	write('. '); end
      else if MsgLimit < 70 then begin
	writeln(message);
      end { if };
      write(TotalLines, ' lines');
      if Compilation <> intface_sy then write(', ', TotalCode, ' bytes code');
      writeln('.');
      if Compilation = prog_sy then
	writeln('Program compiled as ', CURname^)
      else begin
	if Compilation <> implmnt_sy then begin
	  writeln('Interface compiled as ': 27*ord(Compilation <> intface_sy),
		SYMname^);
	end { if };
	if Compilation <> intface_sy then begin
	  writeln('Implementation compiled as ', CURname^);
	end { if };
      end { if }; end
    else begin
      if Errors = 0 then
	write('Terminated')
      else begin
	write('End of compilation');
      end { if };
      writeln('. ', TotalLines, ' lines. ');
      if Errors <> 0 then begin
	write(Errors, ' error');
	if Errors <> 1 then write('s');
	writeln('.');
	if Warnings <> 0 then begin
	  write(Warnings, ' warning');
	  if Warnings > 1 then write('s');
	  writeln('.');
	end { if };
      end { if };
    end;

    Close(TempFile);		 {         }
    Remove(TempName^);				      {    . }
    (*) {*) if IOresult <> 0 then ;			       {  }
  end { FinishUp };

{-----------------------------------------------------------------------------}