{-----------------------------------------------------------------------------}
{ Initialization of UniPascal Compiler. 		   (c) 1989, 1990 YGP }

  (*) segment (*)
  procedure initialize;
    const switchars = '/-';                       { command line switch chars }
    var test:	boolean;
	StdLvl: levelp;
	StdUnit,					      { unit Standard }
	prog:	idp;				       { user program or unit }
	CFGln:	natural;
	CFGname,					   { Config File name }
	SrcName:  string[79];		    { needed only to open Source file }
	StdFiles: array [0..5] of idp;
	tsi: TmpSaveInfo;
	shp: ^SYMheader;

    procedure HelpUser(Err: ShortCard);
      var p, i: ShortCard;
    begin
      if (Err <> 0) and (CFGname <> '') then
	writeln('Error in config file: ', CFGname, ', line ', CFGln)
      else if Err <> 0 then begin
	p:= 1;			   {    ,     }
	for i:= 0 to ParamCount do begin       {     }
	  ParamStr(i, SrcName); 			       {   }
	  write(SrcName, ' ');                           { Fname used as work }
	  if i < Err then inc(p, length(SrcName)+1);
	end { for i };
	writeln; writeln('^': p);
	writeln('Invalid Command Line Parameter!');
	writeln;
      end { if };

	      {....:...10....:...20....:...30....:...40....:...50....:...60...}
      writeln('Usage: UPC [options] filename [options]');
      writeln('  /Dxxx - define conditionals;');
      writeln('  /Uxxx - paths for used units;');
      writeln('  /Ixxx - paths for include files;');
      writeln('  /Oxxx - paths for object files (link);');
      writeln('  /Lxxx - library name (including path);');
      writeln('  /Txxx - path for temporary file;');
      writeln('  /Sxxx - path for .sym file;');
      writeln('  /Bxxx - path for .bdy file;');
      writeln('  /Pxxx - path for .pgm file;');
      writeln('  /Cxxx - path for code file (.bdy/.pgm/.sym);');
      writeln('  /W+/- - wait for key after an error;');
      writeln('  /$<switch>+/-  switch specified option ON/OFF;');
      writeln('  @xxx - use config file xxx (including path).');
      halt(7);
    end { HelpUser };

    procedure InitGlobals;
      var i: ShortCard;
	  w1, w2, w3, w4: Cardinal;
	  wrk: alpha;
    begin
      (*) GetDate(w1, w2, w3);
      {*) GetDate(w1, w2, w3, w4); {*}
      if w1 < 1980 then w1:= 1980;
      Cver:= 1;
      Cdate:= (w1 - 1980) * $200 + w2 * $20 + w3;
      GetTime(w1, w2, w3, w4);
      Ctime:= w1 * $800 + w2 * $20 + w3 div 2;

      ErrLevel:= 0; Errors:= 0;  Warnings:= 0;	  { No any errors or warnigs. }
      LineCnt:= 1; TotalLines:= 0;		     { No lines compiled yet. }
      Fposition:= 0; Lposition:= -1; Eposition:= -1;
      ErrSy:= other_sy;
      TotalCode:= 0;					 { No code generated. }
      SrcName:= '';                                  { No filename given yet. }
      CondLevel:= 0; TrueLevel:= 0;
      DefaultFiles:= 0;
      CpoolSz:= 0; RelctSz:= 0; CodeSize:= 0;

      dsize:= 0; MaxDsize:= 0;
      (*) FillWord(Ifile, WordSizeOf(Ifile), 0);	     { UniPascal Fill }
      {*) FillChar(Ifile, SizeOf(Ifile), 0);		  { Turbo Pascal Fill }

      for i:= 0 to MaxIncl do new(Ifile[i].f);	   { Allocate space for files }

      { Initialize compiler flags }
      InComment:= false; EOFfound:= false; SkipSource:= false; InDecl:= true;
      InLink:=    false; InPrgrm:=  false; ErrorWait:=  false; PrtErr:= true;

	    {/- serial No -\}
      wrk:= #$00#$00#$00#$00#77#7#$77#$7;	  {     - }
      move(wrk[0], serialNo, 4);     { initialize serial number of a compiler }
									 (*){*)
      serialNo:= serialNo or $80000000;    { Turbo Pascal cross compiler only }

      CFGname:= ''; CURname:= nil;
    end { InitGlobals };

    procedure InitLex;
      var wrk: string;
    begin
      fillchar(LexS, sizeof(LexS), #0);
      with LexS do begin
	IdSize:= 8;				   {  8   }
	flags:= $80 + $10 + $04;  {  ASCII, UpCase lat (ident & keywords) }
	buffer:= addr(TxtBuffer);					      {
	buffsz = 0; index = 0;		         - fillchar }

	fillchar(wrk, sizeof(wrk), #0);

	(*){$W-}(*) begin
	  fillchar(wrk[ord('A')], 26, char(ord(Class_A) + ord(Class_A1)));
	  fillchar(wrk[ord('a')], 26, char(ord(Class_A) + ord(Class_A1)));
	  fillchar(wrk[ord('0')], 10, char(ord(Class_A1) + ord(Class_E)));
	end { $W- };

	wrk[95]:= char(ord(Class_A) + ord(Class_A1));		 { underscore }

	wrk[10]:= Class_D; wrk[12]:= Class_D; wrk[13]:= Class_E; { lf, ff, cr }
	wrk[ 9]:= Class_D; wrk[32]:= Class_D; wrk[26]:= Class_E;{ tab, sp, ^Z }

	wrk[34]:= Class_E; wrk[35]:= Class_E; wrk[36]:= Class_E;    { ", #, $ }
	wrk[39]:= Class_E;					    { '       }

	wrk[38]:= Class_C; wrk[40]:= Class_C; wrk[41]:= Class_C;    { &, (, ) }
	wrk[43]:= Class_C; wrk[44]:= Class_C; wrk[45]:= Class_C;    { +, ,, - }
	wrk[47]:= Class_C; wrk[58]:= Class_C; wrk[59]:= Class_C;    { /, :, ; }
	wrk[60]:= Class_C; wrk[91]:= Class_C; wrk[93]:= Class_C;    { <, [, ] }
	wrk[94]:= Class_C; wrk[123]:=Class_C; wrk[124]:=Class_C;    { ^, {, | }

	wrk[42]:= chr(ord(Class_C) + ord(Class_C1));			  { * }
	wrk[46]:= chr(ord(Class_C) + ord(Class_C1));			  { . }
	wrk[61]:= chr(ord(Class_C) + ord(Class_C1));			  { = }
	wrk[62]:= chr(ord(Class_C) + ord(Class_C1));			  { > }

	(*) GetMemWords(Classes, 128 div 2 {  word });
	{*) GetMem(Classes, 128); {*}
	(*){$W-}(*) Move(wrk, Classes^, 128);

	{$ifdef UniPas}
	wrk:= #1','#1':'#1';'#1'('#1')'#1'['#1']'#1'^'#1'.'
	      #2'..'#1'+'#1'-'#1'*'#1'/'#1'='#2'<>'#1'<'
	      #2'<='#1'>'#2'>='#2':='#1'&'#1'|'#1'{'#2'(*'#0;
	{$else}
	wrk:= #1','#1':'#1';'#1'('#1')'#1'['#1']'#1'^'#1'.'+
	      #2'..'#1'+'#1'-'#1'*'#1'/'#1'='#2'<>'#1'<'+
	      #2'<='#1'>'#2'>='#2':='#1'&'#1'|'#1'{'#2'(*'#0;
	{$endif}

	(*) GetMemWords(ClassCkw, succ(length(wrk)) div 2 {  word });
	{*) GetMem(ClassCkw, length(wrk)); {*}
	Move(wrk[1], ClassCkw^, length(wrk));

	{$ifdef UniPas}
	wrk:= #3'AND'#5'ARRAY'#5'BEGIN'#4'CASE'#5'CONST'#3'DIV'
	      #2'DO'#6'DOWNTO'#4'ELSE'#3'END'#4'FILE'#3'FOR'
	      #8'FUNCTION'#4'GOTO'#2'IF'#14'IMPLEMENTATION'#2'IN'
	      #9'INTERFACE'#5'LABEL'#3'MOD'#3'NIL'#3'NOT'#2'OF'#2'OR'
	      #6'PACKED'#9'PROCEDURE'#7'PROGRAM'#6'RECORD'#6'REPEAT'
	      #7'SEGMENT'#3'SET'#4'THEN'#2'TO'#4'TYPE'#4'UNIT'#5'UNTIL'
	      #4'USES'#3'VAR'#5'WHILE'#4'WITH'#3'XOR'#5'ELSIF'#0;
	{$else}
	wrk:= #3'AND'#5'ARRAY'#5'BEGIN'#4'CASE'#5'CONST'#3'DIV'          +
	      #2'DO'#6'DOWNTO'#4'ELSE'#3'END'#4'FILE'#3'FOR'             +
	      #8'FUNCTION'#4'GOTO'#2'IF'#14'IMPLEMENTATION'#2'IN'        +
	      #9'INTERFACE'#5'LABEL'#3'MOD'#3'NIL'#3'NOT'#2'OF'#2'OR'    +
	      #6'PACKED'#9'PROCEDURE'#7'PROGRAM'#6'RECORD'#6'REPEAT'     +
	      #7'SEGMENT'#3'SET'#4'THEN'#2'TO'#4'TYPE'#4'UNIT'#5'UNTIL'  +
	      #4'USES'#3'VAR'#5'WHILE'#4'WITH'#3'XOR'#5'ELSIF'#0;
	{$endif}

	ElseIfPos:= length(wrk) - 7;
	(*) GetMemWords(ClassAkw, succ(length(wrk)) div 2 {  word });
	{*) GetMem(ClassAkw, length(wrk)); {*}
	Move(wrk[1], ClassAkw^, length(wrk));

	wrk:=
	    #6'DEFINE'#4'ELSE'#5'ENDIF'#5'IFDEF'#6'IFNDEF'#5'IFOPT'#5'UNDEF'#0;

	(*) GetMemWords(CondKW, succ(length(wrk)) div 2 {  word });
	{*) GetMem(CondKW, length(wrk)); {*}
	Move(wrk[1], CondKW^, length(wrk));

	IdName:= addr(nm);
      end { with };
    end { InitLex };

    procedure InitSets;
    begin
      TypeDels:=       [set_sy, array_sy, record_sy, file_sy];
      SimpTypeBegSys:= [ident,i_const,r_const,c_const,minus_sy,plus_sy,lpar];
      TypeBegSys:=     TypeDels + [arrow_sy, packed_sy] + SimpTypeBegSys;
      BlckBegSys:=     [label_sy, const_sy, type_sy,	  var_sy,
			proc_sy,  func_sy,  segmnt_sy, begin_sy];
      SelectSys:=      [lbra, arrow_sy, period];
      FacBegSys:=      [ident, i_const, r_const, c_const,
			lpar,  lbra,	not_sy,  nil_sy];
      StatBegSys:=     [begin_sy,  goto_sy, if_sy,   while_sy,
			repeat_sy, for_sy,  with_sy, case_sy];
      StatFolSys:=     [semicolon, else_sy, end_sy, until_sy, elsif_sy];
      MulOps:=	       [asterisk, slash, div_sy, mod_sy, and_sy, AndJWsy];
      AddOps:=	       [plus_sy, minus_sy, or_sy, OrJWsy, xor_sy];
      RelOps:=	       [les_sy, leq_sy, grt_sy, geq_sy, neq_sy, eq_sy, inn_sy];
    end { InitSets };

    procedure InitErrors;
    begin
      { Error numbers used when call to TestSy take place }
      FillChar(ErrorSy, SizeOf(ErrorSy), #0);

      { Special Symbols }
      ErrorSy[	   ident]:= 50;  ErrorSy[comma]:= 49;  ErrorSy[    colon]:= 48;
      ErrorSy[ semicolon]:= 47;  ErrorSy[ lpar]:= 45;  ErrorSy[     rpar]:= 46;
      ErrorSy[	    lbra]:= 43;  ErrorSy[ rbra]:= 44;  ErrorSy[   period]:= 42;
      ErrorSy[dbl_period]:= 41;  ErrorSy[eq_sy]:= 39;  ErrorSy[  becomes]:= 40;

      { KeyWors }
      ErrorSy[	begin_sy]:= 21;  ErrorSy[do_sy]:= 22;  ErrorSy[downto_sy]:= 23;
      ErrorSy[	  end_sy]:= 24;  ErrorSy[of_sy]:= 25;  ErrorSy[  prog_sy]:= 17;
      ErrorSy[	 then_sy]:= 26;  ErrorSy[to_sy]:= 27;  ErrorSy[ until_sy]:= 28;

      { for Modula like and name check compilation }
      ErrorSy[	 case_sy]:= 30;  ErrorSy[ for_sy]:= 31; ErrorSy[  if_sy]:= 33;
      ErrorSy[	while_sy]:= 34;  ErrorSy[with_sy]:= 35;

      { Non Standard KeyWords }
      ErrorSy[implmnt_sy]:= 20; ErrorSy[intface_sy]:= 19; ErrorSy[unit_sy]:=18;
    end { InitErrors };

    procedure InitOptions;
      var Op: char;
	  Options: packed array ['A'..'Z'] of char;
    begin
      {  ------- Set Up Compilier Options ------- }
      { Upper case: Switch option, On  by default }
      { Lower case: Switch option, Off by default }
      { period:     not a switch option 	  }

      Options:= '........I...mn.pqr..U.W.Y.';

      SwitchOps:= [];
      for Op:= 'A' to 'Z' do begin
	Opt.All[Op]:= Options[Op] = Op;
	if UpCase(Options[Op]) = Op then begin
	  (*) Incl(SwitchOps, ord(Op) - ord('A'))
	  {*) SwitchOps:= SwitchOps + [ord(Op) - ord('A')] {*};
	end { if };
      end { for };

      Defined:= #7'UNIPAS';                      {    UniPAS }
    end { InitOptions };

    {$ifNdef Q}
    procedure InitUndeclared;
      var lidp: idp;
    begin
      new(UnDeclared[TypeId] (*), TypeId(*));
      with UnDeclared[TypeId]^ do begin
	link:= nil; IdType:= nil; next:= nil;
	IdName:= 'YGP type'; IdClass:= TypeId;
      end { with };

      new(UnDeclared[VarId] (*), VarId(*));
      with UnDeclared[VarId]^ do begin
	link:= nil; IdType:= nil; next:= nil; IdName:= 'YGP var ';
	IdClass:= VarId; IdAddr:= 0; IdFlags:= 0;
      end { with };

      new(UnDeclared[FieldId] (*), FieldId(*));
      with UnDeclared[FieldId]^ do begin
	link:= nil; IdType:= nil; next:= nil; IdName:= 'YGP fld ';
	IdClass:= FieldId; IdOffset:= 0; IdFlags:= 0;
      end { with };

      new(lidp (*), ConstId(*));
      with lidp^ do begin
	link:= nil; IdType:= nil; next:= nil; IdName:= 'YGP cnst';
	IdClass:= ConstId; IdValue.i:= 0; IdFlags:= _nochange;
      end { with };

      UnDeclared[ConstId]:= lidp;
      UnDeclared[ECnstId]:= lidp;

      new(UnDeclared[ProcId] (*), ProcId, UnDecl(*));
      with UnDeclared[ProcId]^ do begin
	link:= nil; IdType:= nil; next:= nil; IdName:= 'procdure';
	IdClass:= ProcId; IdFlags:= 0;
      end { with };

      new(UnDeclared[FuncId] (*), FuncId, UnDecl(*));
      with UnDeclared[FuncId]^ do begin
	link:= nil; IdType:= nil; next:= nil; IdName:= 'function';
	IdClass:= FuncId; IdFlags:= 0;
      end { with lidp^ };

      UnDeclared[UnitId]:=   nil;
      UnDeclared[UnUnitId]:= nil;
      UnDeclared[LabelId]:=  nil;
    end { InitUndeclared };					       {$endif}

    procedure InitTypes;

      procedure InitStdType(var ftp: typep; Size: integer);
      begin
	new(ftp (*), Scalar(*));
	with ftp^ do begin
	  TSize:= Size;
	  TForm:= Scalar;
	end { with ftp^ };
      end { InitStdType };

      procedure InitSubRange(var ftp: typep; RType: typep; Min, Max: LongInt);
      begin
	new(ftp(*), SubRange(*));
	with ftp^ do begin
	  TForm:= SubRange; TSize:= RType^.TSize;
	  RangeType:= RType; tmin:= Min; tmax:= Max;
	end { with ftp^ };
      end { InitSubRange };

    begin { InitTypes }
      InitStdType(int_t,  1);
      InitStdType(card_t, 1);
      InitStdType(lint_t, 2);
      InitStdType(char_t, 1);
      InitStdType(wrd_t,  1);
      InitStdType(lwrd_t, 2);

      InitSubRange(scrd_t, card_t,    0,   255);
      InitSubRange(sint_t, int_t,  -128,   127);
      InitSubRange(ntrl_t, card_t,    0, 32767);
      InitSubRange(byte_t, wrd_t,     0,   255);

      new(bool_t(*), Enumerated (*));
      with bool_t^ do begin
	TSize:= 1; TForm:= Enumerated;
      end { with bool_t^ };

      new(str_t(*), Strings(*));
      with str_t^ do begin
	TSize:= 0; TForm:= Strings; StrSize:= 0;
      end { with str_t^ };

      new(Mstr_t(*), Strings(*)); { MaxString }
      with Mstr_t^ do begin
	TSize:= 128; TForm:= Strings; StrSize:= 255;
      end { with Mstr_t^ };

      new(AnyType(*), UnTyped (*));
      with AnyType^ do begin
	TSize:= 1; TForm:= UnTyped;
      end { with AnyType^ };

      new(ptr_t(*), Pointers(*));
      with ptr_t^ do begin
	TSize:= 1; TForm:= Pointers; PointedTp:= AnyType;
      end { with ptr_t^ };

      new(txt_t(*), Files(*));
      with txt_t^ do begin
	TSize:= 8; TForm:= Files; FileType:= char_t; RecBytes:= 1;
      end { with txt_t^ };

      new(file_t(*), Files(*));
      with file_t^ do begin
	TForm:= Files; TSize:= 8; FileType:= nil; RecBytes:= 0;
      end { with file_t^ };

      new(real_t(*), Reals(*));
      with real_t^ do begin
	TSize:= 2; TForm:= Reals;
      end { with real_t^ };
    end { InitTypes };

    procedure InitPredefined;
      var TrueId, FalseId: idp;
	  TypeCnt: Natural;

      procedure EnterType(ftp: typep; (*) const (*) fname: alpha);
	var lidp: idp;
      begin
	inc(TypeCnt);
	new(lidp (*), TypeId, true(*));
	with lidp^ do begin
	  IdType:= ftp; IdName:= fname; next:= ExportTypes;
	  IdClass:= TypeId; TypeNo:= TypeCnt; IdFlags:= 0;
	end { with lidp^ };
	ExportTypes:= lidp;  {  export-    next }
	EnterId(lidp);
      end { EnterType };

    begin { InitPredefined }
      ExportTypes:= nil; {       STANDARD}
      { ,      ExportTypes.			      }
      TypeCnt:= 0;		     { TypeNo: }
      EnterType(int_t,	'INTEGER ');      {  1 }
      EnterType(sint_t, 'SHORTINT');      {  2 }
      EnterType(lint_t, 'LONGINT ');      {  3 }
      EnterType(card_t, 'CARDINAL');      {  4 }
      EnterType(scrd_t, 'SHORTCAR');      {  5 }
      EnterType(ntrl_t, 'NATURAL ');      {  6 }
      EnterType(char_t, 'CHAR    ');      {  7 }
      EnterType(bool_t, 'BOOLEAN ');      {  8 }
      EnterType(real_t, 'REAL    ');      {  9 }
      EnterType(str_t,	'STRING  ');      { 10 }
      EnterType(ptr_t,	'POINTER ');      { 11 }
      EnterType(file_t, 'FILE    ');      { 12 }
      EnterType(txt_t,	'TEXT    ');      { 13 }
      EnterType(lwrd_t, 'LONGWORD');      { 14 }
      EnterType(wrd_t,	'WORD    ');      { 15 }
      EnterType(byte_t, 'BYTE    ');      { 16 }
      EnterType(AnyType,'---var--');      { 17 }
      EnterType(Mstr_t, '-string-');      { 17 }

      level^.ExpTypes:= ExportTypes; ExportTypes:= nil;

      { Initialize boolean constants };
      new(FalseId(*), ECnstId(*));
      with FalseId^ do begin
	IdType:= Bool_t; IdName:= 'FALSE   '; IdClass:= ECnstId;
	No:= 0; next:= nil; IdFlags:= _nochange;
      end { with FalseId^ };
      EnterId(FalseId);

      new(TrueId(*), ECnstId(*));
      with TrueId^ do begin
	IdType:= Bool_t; IdName:= 'TRUE    '; IdClass:= ECnstId;
	No:= 1; next:= FalseId; IdFlags:= _nochange;
      end { with TrueId^ };
      EnterId(TrueId);

      bool_t^.LastConst:= TrueId;
    end { InitPredefined };

    procedure EnterStdVars;
      var StdFileNo: 0..4;

      procedure ExtrnlFile((*) const (*) fname: string);
	var lidp: idp; l: ShortCard;
      begin
	l:= length(fname);
	new(lidp (*), VarId(*));
	with lidp^ do begin
	  IdType:= txt_t;
	  if 8 <= l then
	    l:= 8
	  else begin (*){$W-}(*)
	    FillChar(IdName[0], SizeOf(IdName), ' ');
	  end { if };
	  Move(fname[1], IdName, l);
	  IdClass:= VarId; IdAddr:= dsize; inc(dsize, 8);
	  IdFlags:= 0;
	end { with lidp^ };
	EnterId(lidp); StdFiles[StdFileNo]:= lidp; Inc(StdFileNo);
      end { ExtrnlFile };

    begin { EnterStdVars }
      dsize:= 0 {    };
      StdFileNo:= 0;
      ExtrnlFile('INPUT');
      ExtrnlFile('OUTPUT');
      ExtrnlFile('MESSAGE');
      ExtrnlFile('AUXILIARY');
      ExtrnlFile('PRINTER');

      inc(dsize, 4); { Default In/Out, RandSeed }

      dsize:= 0; {    }
    end { EnterStdVars };

    procedure InitSTDpf;
      procedure EnterSTDpf(fSTDpf: StdProcs;
			   FIdClass: Classes;
	       (*)const(*) fname: string);
	var lidp: idp;
	    l: ShortCard;
	    name: alpha;
      begin
	for l:= 0 to 7 do begin 	   {    Initialize   }
	  if l < length(fname) then {       }
	    name[l]:= UpCase(fname[l+1])
	  else begin
	    name[l]:= ' ';
	  end { if };
	end { for };

	new(lidp (*), ProcId{/FuncId}, Standrd(*));
	(*) FillWord(lidp^, WordSizeOf(lidp^, ProcId{/FuncId}, Standrd), 0);
	{*) FillChar(lidp^, SizeOf(lidp^), 0);	  {   max memory }
	with lidp^ do begin
	  IdName:= name; IdClass:= FIdClass; StdPF:= fSTDpf;
	  IdFlags:= _standard;
	end { with };
	EnterId(lidp);
      end { EnterSTDpf };

    begin { InitSTDpf }
					 { Standard IO procedures / functions }
      EnterSTDpf(StdRead,   ProcId, 'read'      );             { ISO standard }
      EnterSTDpf(StdReadln, ProcId, 'readln'    );             { ISO standard }
      EnterSTDpf(StdWrite,  ProcId, 'write'     );             { ISO standard }
      EnterSTDpf(StdWrtLn,  ProcId, 'writeln'   );             { ISO standard }
      EnterSTDpf(StdEof,    FuncId, 'eof'       );             { ISO standard }
      EnterSTDpf(StdEoln,   FuncId, 'eoln'      );             { ISO standard }
      EnterSTDpf(StdReset,  ProcId, 'reset'     );             { ISO standard }
      EnterSTDpf(StdRewrite,ProcId, 'rewrite'   );             { ISO standard }
      EnterSTDpf(StdOpen,   ProcId, 'open'      );         { extension to ISO }
      EnterSTDpf(StdAppend, ProcId, 'append'    );         { extension to ISO }
      EnterSTDpf(StdClose,  ProcId, 'close'     );         { extension to ISO }
      EnterSTDpf(StdBread,  ProcId, 'BlockRead' );         { extension to ISO }
      EnterSTDpf(StdBwrite, ProcId, 'BlockWrite');         { extension to ISO }
      EnterSTDpf(StdSeek,   ProcId, 'seek'      );         { extension to ISO }
      EnterSTDpf(StdFpos,   FuncId, 'FilePos'   );         { extension to ISO }
      EnterSTDpf(StdFsize,  FuncId, 'FileSize'  );         { extension to ISO }
      EnterSTDpf(StdTrunc,  ProcId, 'Truncate'  );         { extension to ISO }

      EnterSTDpf(StdOrd,    FuncId, 'ord'       );             { ISO standard }
      EnterSTDpf(StdOdd,    FuncId, 'odd'       );             { ISO standard }
      EnterSTDpf(StdSucc,   FuncId, 'succ'      );             { ISO standard }
      EnterSTDpf(StdPred,   FuncId, 'pred'      );             { ISO standard }

      EnterSTDpf(StdMin,    FuncId, 'min'       );         { extension to ISO }
      EnterSTDpf(StdMax,    FuncId, 'max'       );         { extension to ISO }

      EnterSTDpf(StdInc,    ProcId, 'inc'       );         { extension to ISO }
      EnterSTDpf(StdDec,    ProcId, 'dec'       );         { extension to ISO }
      EnterSTDpf(StdAbs,    FuncId, 'abs'       );             { ISO standard }
      EnterSTDpf(StdSqr,    FuncId, 'sqr'       );             { ISO standard }

      EnterSTDpf(StdRtrn,   ProcId, 'return'    );         { extension to ISO }
      EnterSTDpf(StdExit,   ProcId, 'exit'      );         { extension to ISO }
      EnterSTDpf(StdHalt,   ProcId, 'halt'      );         { extension to ISO }

      EnterSTDpf(StdFILLC,  ProcId, 'FillChar'  );         { extension to ISO }
      EnterSTDpf(StdFillW,  ProcId, 'FillWord'  );         { extension to ISO }
      EnterSTDpf(StdSizeOf, FuncId, 'SizeOf'    );         { extension to ISO }
      EnterSTDpf(StdWordSz, FuncId, 'WordSizeOf');         { extension to ISO }

      EnterSTDpf(StdRnd,    FuncId, 'random'    );         { extension to ISO }
      EnterSTDpf(StdRndmz,  ProcId, 'randomize' );         { extension to ISO }

      EnterSTDpf(StdIncl,   ProcId, 'incl'      );         { extension to ISO }
      EnterSTDpf(StdExcl,   ProcId, 'excl'      );         { extension to ISO }

      EnterSTDpf(StdMove,   ProcId, 'Move'      );         { extension to ISO }
      EnterSTDpf(StdMoveW,  ProcId, 'MoveWords' );         { extension to ISO }

      EnterSTDpf(StdAddr,   FuncId, 'addr'      );         { extension to ISO }
      EnterSTDpf(StdNew,    ProcId, 'new'       );             { ISO standard }
      EnterSTDpf(StdDispose,ProcId, 'dispose'   );             { ISO standard }
    end { InitSTDpf };

    procedure InitInLinePF;
      var r:   idp;					       { xxx(r: real) }
	  s:   idp;					     { xxx(s: string) }
	  sc:  idp;					 { xxx(sc: shortcard) }
	  w:   idp;					       { xxx(w: word) }
	  l:   idp;					   { xxx(l: LongWord) }
	  ns:  idp;			     { xxx(N: natural; var s: string) }
	  ch:  idp;					      { xxx(ch: char) }
	  vp:  idp;					{ xxx(var p: pointer) }
	  vpn: idp;			    { xxx(var p: pointer, n: Natural) }
	  pn:  idp;				{ xxx(p: pointer, n: Natural) }
	  p:   idp;					    { xxx(p: pointer) }
	  ss:  idp;					{ xxx(s1, s2: string) }
	  ssb: idp;	      { xxx(s1: string; var s2: string; b: shortcard) }
	  sbb: idp;		      { xxx(var s: string; b1, b2: shortcard) }
	  wwww:idp;			      { xxx(var w1, w2, w3, w4: word) }
	  www: idp;				  { xxx(var w1, w2, w3: word) }

      procedure EnterInline((*) const (*) fname: string;
			    Parms: idp; Rslt:  typep;
			    (*) const (*) code: string);
	var lidp: idp;
	    l:	  shortcard;
	    name: alpha;
      begin
	for l:= 0 to 7 do begin 	   {    Initialize   }
	  if l < length(fname) then {       }
	    name[l]:= UpCase(fname[l+1])
	  else begin
	    name[l]:= ' ';
	  end { if };
	end { if };

	new(lidp (*), ProcId{/FuncId}, InLinePF(*));
	(*) FillWord(lidp^, WordSizeOf(lidp^, ProcId{/FuncId}, InLinePf), 0);
	{*) FillChar(lidp^, SizeOf(lidp^), 0);	  {   max memory }
	with lidp^ do begin
	  IdType:= Rslt;
	  next:= Parms; IdName:= name;
	  if Rslt = nil then
	    IdClass:= ProcId
	  else begin
	    IdClass:= FuncId;
	  end { if };
	  IdFlags:= _inline;
	  InLineSz:= length(code);
	  (*) GetMemWords(InLineCode, (length(code)+1) div 2);
	  {*) GetMem(InLineCode, length(code)); {*}
	  Move(code[1], InLineCode^, length(code));
	end { with };
	EnterId(lidp);
      end { EnterInline };

      procedure InitParms;
      begin
	new(r(*), VarId(*));
	with r^ do begin
	  link:= nil; next:= nil; IdType:= real_t;
	  IdClass:= VarId; IdFlags:= 0;
	end { wiht r^ };

	new(s(*), VarId(*));
	with s^ do begin
	  link:= nil; next:= nil; IdType:= str_t; IdClass:= VarId; IdFlags:= 0;
	end { wiht s^ };

	new(w(*), VarID(*));
	with w^ do begin
	  link:= nil; next:= nil; IdType:= wrd_t; IdClass:= VarId; IdFlags:= 0;
	end { wiht w^ };

	new(l(*), VarID(*));
	with l^ do begin
	  link:= nil; next:= nil; IdType:= lwrd_t;
	  IdClass:= VarId; IdFlags:= 0;
	end { wiht l^ };

	new(ns(*), VarId(*));		   { Create parameters for proc/func: }
	with ns^ do begin		    { xxx(N: Natural; var ns: string) }
	  link:= nil; IdType:= ntrl_t; IdClass:= VarId; IdFlags:= 0;
	  new(next(*), VarId(*));
	  with next^ do begin
	    link:= nil; next:= nil;
	    IdType:= str_t; IdFlags:= _byaddr; IdClass:= VarId;
	  end { with next^ };
	end { wiht ns^ };

	new(ch(*), VarID(*));		   { Create parameters for proc/func: }
	with ch^ do begin				      { xxx(ch: char) }
	  link:= nil; IdType:= char_t; next:= nil;
	  IdClass:= VarId; IdFlags:= 0;
	end { wiht ch^ };

	new(vp(*), VarId(*));
	with vp^ do begin
	  link:= nil; next:= nil;
	  IdType:= ptr_t; IdClass:= VarId; IdFlags:= _byaddr;
	end { wiht vp^ };

	new(vpn(*), VarId(*));
	with vpn^ do begin
	  link:= nil; IdType:= ptr_t; IdClass:= VarId; IdFlags:= _byaddr;
	  new(next (*), VarId(*));
	  with next^ do begin
	    link:= nil; next:= nil;
	    IdType:= ntrl_t; IdClass:= VarId; IdFlags:= 0;
	  end { with next^ };
	end { wiht vpn^ };

	new(pn(*), VarId(*));
	with pn^ do begin
	  link:= nil; IdType:= ptr_t; IdClass:= VarId; IdFlags:= 0;
	  new(next (*), VarId(*));
	  with next^ do begin
	    link:= nil; next:= nil;
	    IdType:= ntrl_t; IdClass:= VarId; IdFlags:= 0;
	  end { with next^ };
	end { wiht pn^ };

	new(p(*), VarId(*));
	with p^ do begin
	  link:= nil; next:= nil; IdType:= ptr_t; IdClass:= VarId; IdFlags:= 0;
	end { wiht p^ };

	new(w(*), VarID(*));
	with w^ do begin
	  link:= nil; IdType:= wrd_t; IdClass:= VarId;
	  next:= nil; IdFlags:= 0;
	end { wiht w^ };

	new(l(*), VarID(*));
	with l^ do begin
	  link:= nil; IdType:= lwrd_t; IdClass:= VarId;
	  next:= nil; IdFlags:= 0;
	end { wiht l^ };

	new(wwww(*), VarId(*));
	with wwww^ do begin
	  link:= nil; IdType:= wrd_t; IdClass:= VarId; IdFlags:= _byaddr;
	  new(next(*), VarId(*)); www:= next;
	  with next^ do begin
	    link:= nil; IdType:= wrd_t; IdClass:= VarId; IdFlags:= _byaddr;
	    new(next(*), VarId(*));
	    with next^ do begin
	      link:= nil; IdType:= wrd_t; IdClass:= VarId; IdFlags:= _byaddr;
	      new(next(*), VarId(*));
	      with next^ do begin
		link:= nil; next:= nil;
		IdType:= wrd_t; IdClass:= VarId; IdFlags:= _byaddr;
	      end { with };
	    end { with };
	  end { with };
	end { wiht wwww };

	new(ss(*), VarId(*));
	with ss^ do begin
	  link:= nil; IdType:= str_t; IdClass:= VarId; IdFlags:= 0;
	  new(next(*), VarId(*));
	  with next^ do begin
	    link:= nil; next:= nil;
	    IdType:= str_t; IdClass:= VarId; IdFlags:= 0;
	  end { with next^ };
	end { wiht ss^ };

	new(ssb(*), VarId(*));
	with ssb^ do begin
	  link:= nil; IdType:= str_t; IdClass:= VarId; IdFlags:= 0;
	  new(next(*), VarId(*));
	  with next^ do begin
	    link:= nil; IdType:= str_t; IdClass:= VarId; IdFlags:= _byaddr;
	    new(next(*), VarId (*)); sc:= next;
	    with next^ do begin
	      link:= nil; next:= nil;
	      IdType:= scrd_t; IdClass:= VarId; IdFlags:= 0;
	    end { with next^ };
	  end { with next^ };
	end { wiht ssb^ };

	new(sbb(*), VarId(*));
	with sbb^ do begin
	  link:= nil; IdType:= str_t; IdClass:= VarId; IdFlags:= _byaddr;
	  new(next(*), VarId(*));
	  with next^ do begin
	    link:= nil; IdType:= scrd_t; IdClass:= VarId; IdFlags:= 0;
	    next:= sc;
	  end { with next^ };
	end { wiht sbb };

      end { InitParms };

    begin { InitInLinePF }
      InitParms;				   {    }

      EnterInline('sqrt',       r,    real_t, #$5d#$87);       { ISO standard }
      EnterInline('trunc',      r,    lint_t, #$5d#$96);       { ISO standard }
      EnterInline('round',      r,    lint_t, #$5d#$97);       { ISO standard }
      EnterInline('sin',        r,    real_t, #$5d#$88);       { ISO standard }
      EnterInline('cos',        r,    real_t, #$5d#$89);       { ISO standard }
      EnterInline('exp',        r,    real_t, #$5d#$8a);       { ISO standard }
      EnterInline('ln',         r,    real_t, #$5d#$8b);       { ISO standard }
      EnterInline('arctan',     r,    real_t, #$5d#$8c);       { ISO standard }

      EnterInline('int',        r,    real_t, #$5d#$8d);   { extension to ISO }
      EnterInline('frac',       r,    real_t, #$5d#$8e);   { extension to ISO }

      EnterInline('length',     s,    scrd_t, #$e8);       { extension to ISO }

      EnterInLine('IOresult',   nil,  wrd_t,  #$5f#8);     { extension to ISO }
      EnterInLine('ParamCount', nil,  ntrl_t, #$5e#52);    { extension to ISO }
      EnterInLine('ParamStr',   ns,   nil,    #$5e#53);    { extension to ISO }
      EnterInLine('MsgLimit',   nil,  ntrl_t, #$5e#54);    { extension to ISO }

      EnterInLine('UpCase',     ch,   char_t, #$5f#$34#$80);{extension to ISO }
      EnterInLine('chr',        sc,   char_t, '');             { ISO standrad }

      {Mark, GetMemWords acts as a functions, so generate code to store result}
      EnterInline('Mark',       vp,   nil,    #$5f#$5a#$dc);{extension to ISO }
      EnterInLine('GetMemWords',vpn,  nil,    #$5f#$58#$dc);{extension to ISO }
      EnterInline('FreeMemWord',pn,   nil,    #$5f#$59);   { extension to ISO }
      EnterInline('Release',    p,    nil,    #$5f#$5b);   { extension to ISO }
      EnterInline('MaxAvail',   nil,  ntrl_t, #$5f#$5e);   { extension to ISO }
      EnterInline('MemAvail',   nil,  ntrl_t, #$5f#$5f);   { extension to ISO }

      EnterInLine('Hi',         w,    byte_t, #$5f#$20#$08);{extension to ISO }
      EnterInLine('Lo',         w,    byte_t, #$5f#$20#$28);{extension to ISO }
      EnterInLine('HiWord',     l,    wrd_t,  #$5f#$20#$90);{extension to ISO }
      EnterInLine('LoWord',     l,    wrd_t,  #$5f#$20#$b0);{extension to ISO }
      EnterInLine('Swap',       w,    wrd_t,  #$5f#$21#$08);{extension to ISO }
      EnterInLine('LongSwap',   l,    lwrd_t, #$5f#$21#$90);{extension to ISO }

      EnterInline('GETDATE',    www,  nil,    #$5f#$26);   { extension to ISO }
      EnterInline('GETTIME',    wwww, nil,    #$5f#$27);   { extension to ISO }

      EnterInLine('DELETE',     sbb,  nil,    #$5f#$35);   { extension to ISO }
      EnterInLine('INSERT',     ssb,  nil,    #$5f#$36);   { extension to ISO }
      EnterInLine('POS',        ss,   scrd_t, #$5f#$37);   { extension to ISO }
    end { InitInLinePF };

    procedure ParseParameters;
      label NoConfig;
      type str255 = string[255];
      var Pcnt:  natural;
	  ch:	 char;
	  noPGM,
	  noBDY,
	  noSYM: boolean;
	  usesnm,
	  inclpaths,
	  objectpaths,
	  wrk:	 str255;
	  codenm,
	  tempnm,
	  libnm,
	  symnm,
	  bdynm,
	  pgmnm: string[79];
	  CFGfile: text;


      function AllocStr((*) const (*) s: string; space: shortcard): StringP;
	var p: StringP;
      begin
      (*) GetMemWords(p, (length(s) + space + (1 + 1)) div 2);
      {*) GetMem(p, length(s) + space + 1); {*}
      p^:= s;
      AllocStr:= p;
      end { AllocStr };

      procedure ProcessCmd;
	var i, slash: natural;

	procedure AddBackSlash;
	begin
	  if (wrk <> '') and not (wrk[length(wrk)] in ['\', ':']) then begin
	    insert('\', wrk, length(wrk)+1);
	  end { if };
	end { AddBackSlash };

      begin { ProcessCmd }
	{         ,       }
	{      ( /D  /U..., /I..., /O...)  }
	{      .     UPC.cfg   }
	{	/D boza kosmata = /Dboza;kosmata			      }
	{	/U boza kosmata = /Uboza;kosmata	 ..		      }
	{        /D boza kosmata = /Dbozakosmata	      }

	repeat i:= pos(',', wrk);               {   ','  ';' }
	  if i <> 0 then begin
	    wrk[i]:= ';';
	  end { if };
	until i = 0;

	i:= 0; slash:= 3;
	repeat i:= pos(' ', wrk);
	  if i = 0 then begin
	    i:= pos(#9, wrk);
	  end { if };
	  if i <> 0 then begin
	    if i = slash then
	      delete(wrk, i, 1)
	    else begin
	      wrk[i]:= ';'; slash:= succ(i);
	    end { if };
	  end { if };
	until i = 0;

	if wrk = '' then (*) return {*) exit {*};             { Nothing to do }

	if pos(wrk[1], switchars) <> 0 then begin   {   switch char }
	  delete(wrk, 1, 1);				 {  switch char }
	  ch:= UpCase(wrk[1]);
	  if (wrk = '') or              {  switch char     }
             not(ch in ['$', 'B'..'D', 'I', 'L',
                        'O', 'P', 'S'..'U', 'W'])then begin
	    HelpUser(Pcnt);
	  end { if };

	  delete(wrk, 1, 1);				       {  ch- }
	  case ch of
	    '$': begin                        { Switch Compiler Option ON/OFF }
	      if (length(wrk) <> 2) or
		  not(ord(UpCase(wrk[1])) - ord('A') in SwitchOps) or
		  not(wrk[2] in ['+', '-']) then begin
		HelpUser(Pcnt);
	      end { if };
	      Opt.All[UpCase(wrk[1])]:= wrk[2] = '+';
	    end { when $ };

	    'D': begin      { /Dxxx define symbol for conditional compilation }
	      while (wrk <> '') and (wrk[1] = ';') do delete(wrk, 1, 1);
	      if wrk = '' then HelpUser(Pcnt);
	      if wrk[length(wrk)] <> ';' then begin
		insert(';', wrk, succ(length(wrk)));
	      end { if };
	      for i:= 1 to length(wrk) do begin
		wrk[i]:= UpCase(wrk[i]);
		if not (wrk[i] in ['A'..'Z', '_', ';', '0'..'9']) then begin
		  HelpUser(Pcnt);
		end { if };
	      end { for };
	      while wrk <> '' do begin
		i:= 0;
		while wrk[1] <> ';' do begin
		  if i < 8 then begin
		    if MaxDef <= length(defined) then begin   {    }
		      error(238); HelpUser(Pcnt);      {    defined }
		    end { if };
		    inc(i); insert(wrk[1], defined, i);
		  end { if };
		  delete(wrk, 1, 1);
		end { while };
		if i <> 0 then begin
		  insert(chr(succ(i)), defined, 1);	      { insert length }
		end { if };
		while (wrk <> '') and (wrk[1] = ';') do delete(wrk, 1, 1);
	      end { while };
	    end { when D };

	    'T': begin                        { /Txxx path for temporary file }
	      AddBackSlash; tempnm:= wrk;
	    end { when T };

	    'S': begin                             { /Sxxx path for .sym file }
	      AddBackSlash; symnm:= wrk; noSYM:= false; 	  {  /Cxxx }
	    end { when S };

	    'B': begin                             { /Bxxx path for .bdy file }
	      AddBackSlash; bdynm:= wrk; noBDY:= false; 	  {  /Cxxx }
	    end { when B };

	    'P': begin                             { /Pxxx path for .pgm file }
	      AddBackSlash; pgmnm:= wrk; noPGM:= false; 	  {  /Cxxx }
	    end { when P };

	    'C': begin              { /Cxxx path for .pgm / .bdy / .sym files }
	      AddBackSlash; codenm:= wrk;    {       }
	      if noPGM then pgmnm:= '';   {    /Cxxx    }
	      if noSYM then symnm:= '';    {      upc.cfg }
	      if noBDY then bdynm:= '';
	    end { when C };

	    'L': begin          { /Lxxx name of library file (including path) }
	      libnm:= wrk;
	    end { when L };

	    'U', 'I', 'O': begin    { /(U|I|O)xxx paths for units, inc or obj }
	      insert(';', wrk, length(wrk)+1);   {    GetIntfc }
	      {   ;         ;;      }
	      i:= 1;	     {    ';'    '\'   }
	      while i <= length(wrk) do begin
		if (wrk[i] = ';') and (i <> 1) and
		   not (wrk[i-1] in [';', '\', ':']) then begin
		  insert('\', wrk, i);
		end { if };
		inc(i);
	      end { while };
	      case ch of
		'I': inclpaths:=   wrk;             { paths for include files }
		'O': objectpaths:= wrk;              { paths for object files }
		'U': usesnm:=      wrk;                { paths for used units }
	      end { case };
	    end { when U, I or O };

            'W': begin                             { wait for key after error }
              ErrorWait:= (wrk = '+') or (wrk = '');
              if not ErrorWait and (wrk <> '-') then
                HelpUser(Pcnt);
            end { when W };

	  end { case } end
	else if SrcName = '' then begin {       }
	  i:= length(wrk);  {        .  \ }
	  slash:= i +ScanFor('\', wrk, i, -i); {       }
	  if i-slash = ScanFor('.', wrk, slash+1, i - slash) then begin
	    insert('.pas', wrk, i+1);
	  end { if };
	  SrcName:= wrk; end
	else begin
	  HelpUser(Pcnt);	       {       }
	end { if };
      end { ProcessCmd };

    begin { ParseParameters }
      OBJpaths:= nil; INCpaths:= nil;
      noBDY:= true; noSYM:= true; noPGM:= true;
      tempnm:= ''; usesnm:= ''; SrcName:= ''; libnm:= '\system.upl';
      symnm:=  ''; bdynm:=  ''; pgmnm:=   ''; codenm:=  '';
      inclpaths:= ''; objectpaths:= '';

      Pcnt:= 1; CFGname:= '';
      while (Pcnt <= ParamCount) and (CFGname = '') do begin
	ParamStr(Pcnt, wrk);		   {      config  }
	if wrk[1] <> '@' then
	  inc(Pcnt)
	else begin
	  CFGname:= wrk; delete(CFGname, 1, 1);
	  if CFGname = '' then begin
	    goto NoConfig;
	  end { if };
	end { if };
      end { while };
      if CFGname = '' then CFGname:= 'upc.cfg';
      (*) reset(CFGfile, CFGname);
      {*) filemode:= 0; assign(CFGfile, CFGname); reset(CFGfile); {*}
      CFGln:= IOresult;
      if CFGln <> 0 then begin {     ,    }
	ParamStr(0, wrk);		   { exec dir-. Get path of compiler }
	if Pcnt <= ParamCount then begin {         }
	  writeln('*** Config file not found!');
	  CFGname:= ''; HelpUser(Pcnt);                     {    }
	end { if };
	CFGln:= length(wrk) + ScanFor('\', wrk, length(wrk), -length(wrk));
	if CFGln <> 0			    {     }
	  then wrk[0]:= chr(CFGln)			     {   }
	  else wrk[0]:= chr(pos(':', wrk));          {   }
	if wrk = '' then     {   ''         }
	  CFGln:= 1
	else begin
	  insert(wrk, CFGname, 1);
	  (*) reset(CFGfile, CFGname);
	  {*) filemode:= 0; assign(CFGfile, CFGname); reset(CFGfile);		  {*}
	  CFGln:= IOresult;
	end { if }
      end { if };

      if CFGln = 0 then begin
	while not eof(CFGfile) do begin
	  readln(CFGfile, wrk); inc(CFGln);
	  while (wrk <> '') and (wrk[1] in [' ', #9]) do delete(wrk, 1, 1);
	  while wrk[length(wrk)] in [' ', #9] do dec(wrk[0]);
	  if (wrk <> '') and not (wrk[1] in [';', '#']) then ProcessCmd;
	end { while };
	Close(CFGfile);
      end { if };

NoConfig:
      CFGname:= '';
      noBDY:= true; noSYM:= true; noPGM:= true;    {      }
      { ,      upc.cfg   /Cxxx .    }
      for Pcnt:= 1 to ParamCount do begin
	ParamStr(Pcnt, wrk);			 { Get command line parameter }
	if wrk[1] <> '@' then ProcessCmd;
      end { for };

      if SrcName = '' then HelpUser(0); {       }

      TempName:= AllocStr(tempnm, 12);
      LibName:= AllocStr(libnm, 0);

      if symnm = '' then symnm:= codenm;
      if bdynm = '' then bdynm:= codenm;
      if pgmnm = '' then pgmnm:= codenm;

      SYMname:= AllocStr(symnm, 12);
      BDYname:= AllocStr(bdynm, 12);
      PGMname:= AllocStr(pgmnm, 12);
      UsesPaths:= AllocStr(usesnm, 0);

      if inclpaths <> '' then begin
	INCpaths:= AllocStr(inclpaths, 0)
      end { if };

      if objectpaths <> '' then begin
	OBJpaths:= AllocStr(objectpaths, 0)
      end { if };
    end { ParseParameters };

    procedure CreateLevel;
    begin
      LastLevel:= level;
      new(prog (*), ProcId, Declared(*));
      with prog^ do begin
	IdClass:= ProcId; IdFlags:= _overlay;
	next:= nil; IdType:= nil;
	move(prognm[1], IdName, 8);
	pf.seg:= 0; pf.num:= 1; pf.psize:= 0;
      end { with prog^ };

      EnterId(prog); level^.Proc:= prog;

      ProcNo:= 1; NextProc:= 2; SegNo:= 0; NextSeg:= 1;

      new(StdUnit (*), UnitId(*)); Units:= StdUnit;
      FillChar(StdUnit^, SizeOf(StdUnit^ (*), UnitId(*)), #0);
      with StdUnit^ do begin
	Intface:= StdLvl; IdName:= 'STANDARD'; IdClass:= UnitId;
	(* IdFlags:= _interfaced;   interface only  *)
      end { with StdUnit^ };

      EnterId(StdUnit); Nunits:= 0;

      mark(level^.MarkHeap);
    end { CreateLevel };

    procedure GetExternalFiles;
      var lidp: idp; fno: 0..5;
	  InFiles, OutFiles: set of 0..4;
    begin
      InFiles:=  [0, 2, 3];			       { Input,  Message, Aux }
      OutFiles:= [1, 2, 3, 4];		      { Output, Message, Aux, Printer }
      while sy = ident do begin
	QualIdent([VarId], lidp);
	fno:= 0; StdFiles[5]:= lidp;				{  }
	while lidp <> StdFiles[fno] do Inc(fno);
	if fno in InFiles then begin
	  InFiles:= [];
	  DefaultFiles:= DefaultFiles or (fno+1) * 256;
	end { if };
	if fno in OutFiles then begin
	  OutFiles:= [];
	  DefaultFiles:= DefaultFiles or (fno+1);
	end { if };
	if fno = 5 then begin ErrSy:= ident; Error(75); end;
	insy;
	if sy = comma then
	  insy
	else begin
	  (*) return {*) exit {*};
	end { if }
      end { while };
    end { GetExternalFiles };

  begin { initialize }
    TotalLines:= 0;	       {         }

    {     `       }

    (*) writeln('UniPascal compiler  Version 1.69`': -40,
		'(c) 1989, 90 Software R&D Lab., Sofia': 39);
    {*)writeln(
     'UniPascal compiler  Version 1.69`    (c) 1989,90 Software R&D Lab.'
     + ' IBM PC/XT/AT.');                                      { Turbo Pascal }

    (*) NoMemFulMsg; (*)                 { disable 'Run Time Error 1' message }
    InInit:= true;			 {     }

    InitGlobals;			  { Initialize main global variables. }
    InitOptions;		       { Initialize default compiler options. }
    InitLex;				      { Initialize lexical structure. }
    InitSets;				 { Initialize start/stop symbol sets. }
    InitErrors; 		    { Initialize errors for expected symbols. }

    ParseParameters;		{      }
    Ilevel:= 0; 		    { Open Sorce file as 0 level include file }
    OpenIfile(SrcName); WriteFname;

    insy;						   { Get first symbol }
    if not Opt.ModulaLike then bap(LexS.ClassAkw)^[ElseIfPos]:= 0;  {del elsif}

    InInit:= false;
								    {$ifNdef Q}
    InitUndeclared;						       {$endif}
    new(level(*), UnitLvl(*));			   {  unit Standard. }
    (*)FillWord(level^, WordSizeOf(level^, UnitLvl), 0);     { UniPascal fill }
    {*)FillChar(level^,   SizeOf(level^),	   0);	  { Turbo Pascal Fill }
    with level^ do begin     {       . }(*
      Idents:= nil; DBLids:= nil; PrevLevel:= nil;	    
      Ver:= 0; Date:= 0; Time:= 0;			      FILLCHAR	     *)
      LvlKind:= UnitLvl; UnitNo:= 255;
    end { with level^ };

    StdLvl:= level;

    InitTypes;			    { Standard types (integer, boolean, etc.) }
    InitPredefined;			    { Identifiers of a standard types }
    InitSTDpf;				    { initialize standard procs/funcs }
    InitInLinePF;		      { initialize standard inline proc/funcs }
    EnterStdVars;			 { Standard files: input, output, ... }

    new(level (*), PFlvl(*));
    (*)FillWord(level^, WordSizeOf(level^, PFlvl), 0);	     { UniPascal fill }
    {*)FillChar(level^,   SizeOf(level^),	 0);	  { Turbo Pascal fill }
    with level^ do begin
      LvlKind:= PFlvl;
    end { with level^ };

    test:= true;				{    }
    if sy in [prog_sy, unit_sy, intface_sy, implmnt_sy] then begin
      Compilation:= sy; insy; end
    else begin
      error(17);		      {      }
      Compilation:= prog_sy;
      test:= sy = ident;				{   header? }
      if test then insy;	  {   keyword,     header }
    end { if };

    if Compilation in [intface_sy, implmnt_sy] then TestSy(unit_sy);

    if sy <> ident then begin
      prognm:= '$NoName$';             {     ,    }
      if test then Error(50);		      {   user-   }
      CreateLevel; end
    else begin
      LexLevel:= 0; prognm:= nm; write(message, #13);
      fillchar(prognm[length(prognm)+1], 8 - length(prognm), ' ');
      (*)write(Ifile[Ilevel].fname:15, '(', LLineCnt:4, ') ',nm: -9, 's0');
      {*)if length(Ifile[Ilevel].fname) <= 15 then
	   write(Ifile[Ilevel].fname:15)
	 else begin
           write(MinimizeFname(Ifile[Ilevel].fname): 15);
	 end;
	 write('(', LLineCnt:4, ') ', nm, '': 9-length(nm), 's0');
      {*}
      WriteFname; CreateLevel;
      (*) write(message, ' ', nm: -8);
      {*) write(message, ' ', nm, '': 9-length(nm) );
      {*}

      insy;

      if sy = lpar then begin {       }
	if Compilation <> prog_sy then begin
	  if Compilation = implmnt_sy then
	    error(74)
	  else begin
	    insy; Constant(BlckBegSys + StatBegSys - [case_sy] + [rpar]);
	    if {$ifNdef Q}(ga.t <> nil) and{$endif}
	       (ga.t^.TForm = SubRange) then begin
	      ga.t:= ga.t^.RangeType;
	    end { if };
	    if {$ifNdef Q}(ga.t <> nil) and{$endif}
	       (ga.t^.TForm <> Scalar) or (ga.t = char_t) then
	      error(16)
	    else begin
	      Cver:= ga.Aval.i
	    end { if };
	  end { if }; end
	else begin
	  insy; GetExternalFiles;
	end { if };
	TestSy(rpar);
      end { if };
      TestSy(semicolon);
    end { if };

    IntfcOnlyU:= Compilation = unit_sy;

    (*)
      Open(TempFile, TempName^, temporary);
    {*)
      (*          *)
      insert('tempfile.tmp', tempname^, length(tempname^)+1);
      Assign(TempFile, TempName^); rewrite(TempFile, 1);
    {*}

    if IOresult <> 0 then begin
      last.s:= tempname; errsy:= c_const; error(249);
    end { if };
    fillchar(tsi, sizeof(tsi), #0);
    blockwrite(tempfile, tsi, sizeof(tsi));
    if IOresult <> 0 then error(248);
    TempStart:= 0; TempItems:= 0;

    case Compilation of 			      {     }
      intface_sy: begin
	CURname:= SYMname; BDYname:= nil; PGMname:= nil;
      end { when interface };

      unit_sy: begin
	CURname:= SYMname; PGMname:= nil;
      end { when unit };

      implmnt_sy: begin
	CURname:= BDYname; SYMname:= nil; PGMname:= nil;
      end { when implementation };

      prog_sy: begin
	CURname:= PGMname; SYMname:= nil; BDYname:= nil;
      end { when program };
    end { case };

    (*)
      Open(CodeFile, CURname^, temporary);
    {*)
      (*          *)
      insert('CodeFile.TMP', CURname^, length(CURname^)+1);
      Assign(CodeFile, CURname^); rewrite(CodeFile, 1);
    {*}

    if IOresult <> 0 then begin
      last.s:= CURname; errsy:= c_const; error(249);
    end { if };

    if Compilation in [implmnt_sy, prog_sy] then begin
      fillchar(ProcBuff, sizeof(ProcBuff), #0);
      BlockWrite(CodeFile, ProcBuff, 512);
      if IOresult <> 0 then Error(248);
      LastPara:= 0; word(SegStart):= $ffff; OKcode:= 1; end
    else begin
      shp:= addr(ProcBuff);
      with shp^ do begin
	id:= 'UniPascal'#0;
	vmaj:= 1; vmin:= 51;
	serNo:= SerialNo;
      end { with };
      to_code(shp^, sizeof(shp^));
    end { if };

{$ifdef Check_for_Duplicate_import}
    {   '?',     - ,    -   }
    (*) Excl(SwitchOps, ord('?') - ord('A'))
    {*) SwitchOps:= SwitchOps + [ord('?') - ord('A')] {*};
{$endif}
  end { initialize };
{-----------------------------------------------------------------------------}