{$A-,B-,E+,F-,I-,N+,O-,R-,S+,V-,D-,L-}
{$ifdef all} {$D+,L+} {$endif}
unit UPCinlines; interface
  uses UPCglobals, UniPascal;

  function  ScanFor(ch: char; var source; offset: word; lim: integer): integer;

  function  IdSearch(var ls: LexStructure): token;

  function  GetInteger(var Src; offset: word; limit: word; var EndPos: word):
	    LongInt;

  function  GetReal(var Src; offset: word; limit: word; var EndPos: word):
	    Real;

  procedure Remove(fname: string);

  procedure Rename(nm1, nm2: string);

  function Byte2Str(b: byte): string;
  function Word2Str(w: word): string;
  function Lword2Str(l: longint): string;

implementation
  const Class_D  = $01; 			       { separators (skipped) }
	Class_C  = $02; 				   { special keywords }
	Class_E  = $04; 				      { user handling }
	Class_A  = $08; 				{ Class A identifiers }
	Class_B  = $10; 				{ Class B identifiers }
	Class_A1 = $20; 			      { Class A' (A continue) }
	Class_B1 = $40; 			      { Class B' (B continue) }
	Class_C1 = $80; 			      { Class C' (C continue) }

  type ca = packed array [0..1000] of char;
       ba = packed array [0..1000] of byte;

  function ScanFor(ch: char; var source; offset: word; lim: integer): integer;
    label Exit;
    var i: integer;
	cap: ^ca;
  begin
  i:= 0; cap:= addr(ca(source)[offset]);
  if lim >= 0
    then while i < lim do
	   begin
	   if cap^[i] = ch
	     then goto Exit;
	   Inc(i);
	   end
    else while i > lim do
	   begin
	   if cap^[i] = ch
	     then goto Exit;
	   Dec(i);
	   end;
  Exit: ScanFor:= i;
  end { ScanFor };

  function  IdSearch(var ls: LexStructure): token;
    label EndIdSearch;
    type cap = ^ca;
	 bap = ^ba;
	 chp = ^char;
	 btp = ^byte;

    var ClassesP: bap;
	charp: chp;
	offs_charp: word absolute charp;
	end_offs,
	save_offs:  word;
	ch:	    char;
	cls:	    byte;
	Sz:	    byte;
	ASCIIonly:  boolean;
	LoCase:     byte;
	not_UpCaseL,
	not_UpCaseC:boolean;

    function SearchTbl(   tbl: btp;
		       var sz: byte;
			chrp: chp
		      ): word;
      type bap = ^ba;
      var lastno, curno: word;
	  cursz, lastsz:  byte;
	  UpCaseL, UpCaseC: boolean;
	  ch: char;
	  end_offs: word;
	  offs_chrp: word absolute chrp;
	  svchrp: pointer;
	  tbl_offs: word absolute tbl;
	  next_offs: word;
    begin
      sz:= 0; lastno:= 0; (* ndx:= 0; *) curno:= 0;
      end_offs:= offs_charp; svchrp:= chrp;
      UpCaseL:= ls.flags and $04 <> 0; UpCaseC:= ls.flags and $02 <> 0;
      if tbl <> nil then begin
	cursz:= tbl^ (* bap(tbl)^[ndx] *) ;
	while (cursz <> 0) and (offs_chrp <> end_offs) do begin
	  inc(curno); lastsz:= cursz; chrp:= svchrp;
	  next_offs:= succ(tbl_offs + cursz);
	  repeat inc(tbl_offs); ch:= chrp^;
	    if UpCaseL and (ch in ['a'..'z']) or
	       UpCaseC and (ch in [''..'']) then begin
	      dec(ch, $20);
	    end { if };
	    dec(cursz, ord(ch = char(tbl^))); inc(offs_chrp);
	  until (ch <> char(tbl^)) or
		(cursz = 0) or (offs_chrp = end_offs);

	  if (cursz = 0) and (Sz < LastSz) then begin
	    lastno:= curno; sz:= lastsz;
	  end { if };
	  tbl_offs:= next_offs; dec(offs_chrp, cursz);
	  cursz:= tbl^;
	end { while };
      end { if };
      SearchTbl:= lastno;
    end { SearchTbl };

    function Class(ch: char): byte;
    begin
      if (#$80 <= ch) and ASCIIonly then
	Class:= 0
      else begin
	Class:= ClassesP^[ord(ch)];
      end { if };
    end { Class };

  begin { IdSearch }
    with ls do begin
      ASCIIonly:= flags and $80 <> 0; flags:= flags or 1;     { end of buffer }
      ClassesP:= Classes; start:= index; LoCase:= flags and $20;
      not_UpCaseL:= flags and $10 = 0; not_UpCaseC:= flags and $08 = 0;
      if buffsz <= index then
	IdSearch:= EndBuff			      {     }
      else begin
	charp:= addr(cap(buffer)^[index]);
	charp:= ptr(Seg(charp^) + Ofs(charp^) div 16, Ofs(charp^) mod 16);
	cls:= Class(charp^);
	save_offs:= offs_charp; end_offs:= offs_charp + (buffsz - index);
	while (cls and Class_D <> 0) and (offs_charp < end_offs) do begin
	  inc(offs_charp); cls:= Class(charp^); 	       { skip Class D }
	end { while };
	inc(index, offs_charp - save_offs); save_offs:= offs_charp;
	start:= index;
	if index = buffsz then begin
	  IdSearch:= EndBuff; exit
	end { if };
	flags:= flags and $fe;

	if (cls and Class_C <> 0) then begin		 { Class C character? }
	  Sz:= 0;		{    C,C',C',...  }
	  repeat inc(offs_charp); inc(Sz);
	  until (Class(charp^) and Class_C1 = 0) or (offs_charp = end_offs);
	  KeyWordNo:= SearchTbl(ClassCkw, Sz, ptr(seg(charp^), save_offs));
	  offs_charp:= save_offs + sz;
	  if sz <> 0 then begin
	    IdSearch:= Ckeyword;
	    goto EndIdSearch;
	  end { if };
	end { if };

	if cls and Class_E <> 0 then begin		 { Class E character? }
	  IdSearch:= UserCh; inc(offs_charp); end
	else if (cls and Class_A <> 0) then begin	 { Class A character? }
	  bap(IdName)^[0]:= 0;
	  Sz:= IdSize;		{    A,A',A',...  }
	  repeat ch:= chr(ord(charp^) and $df);
	    if (not_UpCaseL or not (ch in ['A'..'Z'])) and
	       (not_UpCaseC or not (ch in [''..''])) then
	      ch:= charp^
	    else begin
	      ch:= chr(ord(ch) or LoCase);
	    end { if };
	    if length(IdName^) < Sz then begin
	      inc(IdName^[0]);
	      IdName^[length(IdName^)]:= ch;
	    end { if };
	    inc(offs_charp);
	  until (Class(charp^) and Class_A1 = 0) or (offs_charp = end_offs);
	  KeyWordNo:= SearchTbl(ClassAkw, Sz, ptr(seg(charp^), save_offs));
	  if Sz = offs_charp - save_offs then
	    IdSearch:= Akeyword
	  else begin
	    IdSearch:= IdentA;
	  end { if }; end
	else if (cls and Class_B <> 0) then begin	 { Class B character? }
	  bap(IdName)^[0]:= 0;
	  Sz:= IdSize;		{    A,A',A',...  }
	  repeat ch:= chr(ord(charp^) and $df);
	    if (not_UpCaseL or not (ch in ['A'..'Z'])) and
	       (not_UpCaseC or not (ch in [''..''])) then
	      ch:= charp^
	    else begin
	      ch:= chr(ord(ch) or LoCase);
	    end { if };
	    if length(IdName^) < Sz then begin
	      inc(IdName^[0]);
	      IdName^[length(IdName^)]:= ch;
	    end { if };
	    inc(offs_charp);
	  until (Class(charp^) and Class_B1 = 0) or (offs_charp = end_offs);
	  KeyWordNo:= SearchTbl(ClassBkw, Sz, ptr(seg(charp^), save_offs));
	  if Sz = offs_charp - save_offs then
	    IdSearch:= Bkeyword
	  else begin
	    IdSearch:= IdentB;
	  end { if }; end
	else begin
	  IdSearch:= InvalidCh; inc(offs_charp);	       { Invalid char }
	end { if };

EndIdSearch:
	inc(index, offs_charp - save_offs);
	flags:= flags or ord(offs_charp = end_offs);
      end { if };
    end { with };
  end { IdSearch };

  function GetInteger(var Src; offset: word; limit: word; var EndPos: word):
	    LongInt;
    type ca = packed array [0..0] of char;
    var nodigits, hex: boolean;
	radix: byte;
	num: LongInt;
	ch: char;
	cap: ^ca;
        start: byte;
  begin
  NoDigits:= true; system.InOutRes:= 0;
  cap:= addr(ca(Src)[offset]);
  start:= 0;
  while (start < limit) and (cap^[start] = ' ') do begin
    inc(EndPos); inc(start);
  end { while };
  hex:= cap^[start] = '$'; radix:= 10 + ord(hex)*6;
  EndPos:= ord(hex) + start; num:= 0; ch:= '_';
  while (ch = '_') and (EndPos < limit) do begin
    ch:= UpCase(cap^[EndPos]);
    while (EndPos < limit) and
	  (('0' <= ch) and (ch <= '9') or
	   hex and ('A' <= ch) and (ch <= 'F')) do begin
      num:= num * radix - ord('0') + ord(ch);
      if 'A' <= ch then num:= num - 7;
      Inc(EndPos); ch:= UpCase(cap^[EndPos]);
      NoDigits:= false;
    end { while };
    while (EndPos < limit) and (cap^[EndPos] = '_') do begin
      inc(EndPos, 1);
    end { while };
  end { while };
  GetInteger:= num;
  if NoDigits then system.InOutRes:= -1;
  end { GetInteger };

  function GetReal(var Src; offset: word; limit: word; var EndPos: word): Real;
    type ca = packed array [0..1000] of char;
    var Ipart, Fpart, Epart: LongInt;
        cap: ^ca; r: real; code, start: integer; s: string;
  begin
  EndPos:= 0; cap:= addr(ca(Src)[offset]); system.InOutRes:= 0; start:= 0;
  while (EndPos < limit) and (cap^[EndPos] = ' ') do begin
    inc(EndPos); inc(start);
  end { while };
  while (EndPos < limit) and (cap^[EndPos] in ['0'..'9', '_']) do Inc(EndPos);
  if (cap^[EndPos] = '.') and (EndPos < limit)
    then repeat Inc(EndPos)
	 until (limit <= EndPos) or not (cap^[EndPos] in ['0'..'9', '_']);
  if (upcase(cap^[EndPos]) = 'E') and (EndPos < limit)
    then begin Inc(EndPos); inc(EndPos, ord(cap^[EndPos] = '_'));
	 if ((cap^[EndPos] = '+') or (cap^[EndPos] = '-')) and
	    (EndPos < limit)
	   then Inc(EndPos);
	 while (EndPos < limit) and (cap^[EndPos] in ['0'..'9', '_']) do
	   Inc(EndPos);
	 end;
  if EndPos = 0 then exit;
  s[0]:= chr(EndPos-start); Move(cap^[start], s[1], EndPos-start);
  while pos('_', s) <> 0 do delete(s, pos('_', s), 1);
  Val(s, r, code);
  if code <> 0 then system.InOutRes:= -1;
  getreal:= r;
  end { GetReal };

  procedure Remove(fname: string);
    var f: file;
  begin
    assign(f, fname);
    system.erase(f);
  end { remove };

  procedure Rename(nm1, nm2: string);
    var f: file;
  begin
    assign(f, nm1);
    system.rename(f, nm2);
  end { rename };

  const hexs: packed array [0..15] of char = '0123456789abcdef';

  function Byte2Str(b: byte): string;
  begin
    Byte2Str:= hexs[b div 16] + hexs[b mod 16];
  end (* Byte2Str *);

  function Word2Str(w: word): string;
  begin
    Word2Str:= Byte2Str(hi(w)) + Byte2Str(lo(w));
  end (* Word2Str *);

  function Lword2Str(l: longint): string;
  begin
    Lword2Str:= Word2Str(hiword(l)) + Word2Str(loword(l));
  end (* Lword2Str *);

end { UPCinlines }.